/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: hid_appli.h 2416 2017-05-28 11:17:20Z roi $
 */

/*
 *	USB HOST HIDץΥإåե
 */
#include "tusb_types.h"

#ifndef TOPPERS_MACRO_ONLY

typedef struct
{
	uint8_t              button_left:1;
	uint8_t              button_right:1;
	uint8_t              button_middle:1;
	int8_t               x;
	int8_t               y;
	int8_t               z;
} MOUSE_Info_t;

typedef struct
{
	uint8_t lctrl:1;
	uint8_t lshift:1;
	uint8_t lalt:1;
	uint8_t lgui:1;
	uint8_t rctrl:1;
	uint8_t rshift:1;
	uint8_t ralt:1;
	uint8_t rgui:1;
	uint8_t keys[6];
} KEYBOARD_Info_t;

TUSBH_ERCODE HidMouseInit(void *phandle);
TUSBH_ERCODE HidMouseInfo(void *phandle, MOUSE_Info_t *p, uint8_t *buffer, uint16_t length);

TUSBH_ERCODE HidKeyboardInit(void *phandle);
TUSBH_ERCODE HidGetKeyboardInfo(void *phandle, KEYBOARD_Info_t *pinfo, uint8_t *buffer, uint16_t length);
uint8_t HidGetASCIICode(KEYBOARD_Info_t *info);

#endif /* TOPPERS_MACRO_ONLY */
