/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2016 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: lcdshield.h 2416 2012-09-07 08:06:20Z ertl-hiro $
 */

/*
 *  LCDץΥإåե
 */

/*
 *  åȰ¸
 */
#include "target_test.h"
#include "usb_otg.h"
#include "tusbh_msc.h"
#include "glcd_disp.h"

/*
 *  ƥͥ٤
 */

#define MAIN_PRIORITY	9		/* ᥤ󥿥ͥ */
								/* HIGH_PRIORITY⤯뤳 */

#define HIGH_PRIORITY	6		/* ¹Լ¹Ԥ륿ͥ */
#define MID_PRIORITY	10
#define LOW_PRIORITY	11

/*
 *  åȤ˰¸ǽΤ
 */

#ifndef TASK_PORTID
#define	TASK_PORTID		1			/* ʸϤ륷ꥢݡID */
#endif /* TASK_PORTID */

#ifndef STACK_SIZE
#define	STACK_SIZE		4096		/* Υå */
#endif /* STACK_SIZE */

//#define SPISDCARD_PORTID    0

#define PORT_HIGH      1
#define PORT_LOW       0 

#define GPIO_OTYPE     GPIO_OTYPE_PP
#ifndef GPIO_SELECT_PDOWN
#define GPIO_PULLMODE  GPIO_PULLUP
#else
#define GPIO_PULLMODE  GPIO_PULLDOWN
#endif

#define BUFFERSIZE      140

#define INHNO_SPI   IRQ_VECTOR_SPI1	/* ߥϥɥֹ */
#define INTNO_SPI   IRQ_VECTOR_SPI1	/* ֹ */
#define INTPRI_SPI  -4          /* ͥ */
#define INTATR_SPI  TA_EDGE     /* ° */

#define INHNO_DMARX   IRQ_VECTOR_DMA2_STREAM2	/* ߥϥɥֹ */
#define INTNO_DMARX   IRQ_VECTOR_DMA2_STREAM2	/* ֹ */
#define INTPRI_DMARX  -4          /* ͥ */
#define INTATR_DMARX  TA_EDGE     /* ° */

#define INHNO_DMATX   IRQ_VECTOR_DMA2_STREAM3	/* ߥϥɥֹ */
#define INTNO_DMATX   IRQ_VECTOR_DMA2_STREAM3	/* ֹ */
#define INTPRI_DMATX  -4          /* ͥ */
#define INTATR_DMATX  TA_EDGE     /* ° */


#define INHNO_USBFS   IRQ_VECTOR_OTG_FS	/* ߥϥɥֹ */
#define INTNO_USBFS   IRQ_VECTOR_OTG_FS	/* ֹ */
#define INTPRI_USBFS  -5			/* ͥ */
#define INTATR_USBFS  0				/* ° */

#define INHNO_FSWKUP  IRQ_VECTOR_OTG_FS_WKUP	/* ߥϥɥֹ */
#define INTNO_FSWKUP  IRQ_VECTOR_OTG_FS_WKUP	/* ֹ */
#define INTPRI_FSWKUP -10			/* ͥ */
#define INTATR_FSWKUP 0				/* ° */


#define INHNO_ADC     IRQ_VECTOR_ADC	/* ߥϥɥֹ */
#define INTNO_ADC     IRQ_VECTOR_ADC	/* ֹ */
#define INTPRI_ADC    -5          /* ͥ */
#define INTATR_ADC    0           /* ° */

#define INHNO_DMAADC  IRQ_VECTOR_DMA2_STREAM0	/* ߥϥɥֹ */
#define INTNO_DMAADC  IRQ_VECTOR_DMA2_STREAM0	/* ֹ */
#define INTPRI_DMAADC -4          /* ͥ */
#define INTATR_DMAADC TA_EDGE     /* ° */

/* Definition for ADCx's Channel */
#define ADCx_CHANNEL                    ADC_CHANNEL_9

/* Definition for ADCx Channel Pin */
#define ADCx_CHANNEL_GPIO_PORT          TADR_GPIOF_BASE
#define ADCx_CHANNEL_PINNO              3

#define NUM_USBH_EVT1   64
#define NUM_USBH_EVT2   16

#define NUM_JSPOSITION 6

#define JS_OFF      0x01
#define JS_ON       0x02
#define JS_UP       0x04
#define JS_DOWN     0x08
#define JS_LEFT     0x10
#define JS_RIGHT    0x20
#define JS_MASK     0x3F

#define CS_PORT     10
#define RST_PORT    9
#define RS_PORT     8
#define CS2_PORT    4

#define cs_set(sw)  digitalWrite(CS_PORT, sw)
#define rs_set(sw)  digitalWrite(RS_PORT, sw)
#define rst_set(sw) digitalWrite(RST_PORT, sw)
#define cs2_set(sw) digitalWrite(CS2_PORT, sw)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ҡΰ
 */
extern uint32_t heap_param[2];

/*
 *  ؿΥץȥ
 */
extern void	main_task(intptr_t exinf);
extern void stick_task(intptr_t exinf);

extern void heap_init(intptr_t exinf);
extern void sw_int(void);
extern void device_info_init(intptr_t exinf);


#endif /* TOPPERS_MACRO_ONLY */
