/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2018 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: mdcard_play.h 2417 2018-07-07 17:05:44Z roi $
 */

/*
 *		ͣ- У̣٣ţҥץΥإåե
 */

#include <stdio.h>
/*
 *  åȰ¸
 */
#include "target_test.h"
#include "storagedevice.h"
#include "device.h"
#include "i2c.h"
#include "sai.h"
#include "stlcd_otm8009a.h"
#include "stts_ft06x06.h"
#include "staudio_wm8994.h"
#if _DRIVES > 1
#include "usb_otg.h"
#include "tusbh_base.h"
#include "mscdiskio.h"
#endif
#include "glcd_disp.h"

/*
 *  ƥͥ٤
 */
#define AUDIO_PRIORITY  2
#define MAIN_PRIORITY	9		/* ᥤ󥿥ͥ */
								/* HIGH_PRIORITY⤯뤳 */

/*
 *  åȤ˰¸ǽΤ
 */

#ifndef TASK_PORTID
#define	TASK_PORTID		1			/* ʸϤ륷ꥢݡID */
#endif /* TASK_PORTID */

#ifndef STACK_SIZE
#define	STACK_SIZE		8192		/* Υå */
#endif /* STACK_SIZE */

#define INHNO_LTDC      IRQ_VECTOR_LTDC
#define INTNO_LTDC      IRQ_VECTOR_LTDC
#define INTPRI_LTDC     -7        /* ͥ */
#define INTATR_LTDC     0         /* ° */

#define INHNO_DSI       IRQ_VECTOR_DSI
#define INTNO_DSI       IRQ_VECTOR_DSI
#define INTPRI_DSI      -7        /* ͥ */
#define INTATR_DSI      0         /* ° */

#define INHNO_I2C1EV    IRQ_VECTOR_I2C1_EV	/* ߥϥɥֹ */
#define INTNO_I2C1EV    IRQ_VECTOR_I2C1_EV	/* ֹ */
#define INTPRI_I2C1EV   -5				/* ͥ */
#define INTATR_I2C1EV   0				/* ° */

#define INHNO_I2C1ER    IRQ_VECTOR_I2C1_ER	/* ߥϥɥֹ */
#define INTNO_I2C1ER    IRQ_VECTOR_I2C1_ER	/* ֹ */
#define INTPRI_I2C1ER   -5				/* ͥ */
#define INTATR_I2C1ER   0				/* ° */

#define INHNO_I2C4EV    IRQ_VECTOR_I2C4_EV	/* ߥϥɥֹ */
#define INTNO_I2C4EV    IRQ_VECTOR_I2C4_EV	/* ֹ */
#define INTPRI_I2C4EV   -5				/* ͥ */
#define INTATR_I2C4EV   0				/* ° */

#define INHNO_I2C4ER    IRQ_VECTOR_I2C4_ER	/* ߥϥɥֹ */
#define INTNO_I2C4ER    IRQ_VECTOR_I2C4_ER	/* ֹ */
#define INTPRI_I2C4ER   -5				/* ͥ */
#define INTATR_I2C4ER   0				/* ° */

#define INHNO_DFSDM1F0  IRQ_DFSDM1_FLT0	/* ߥϥɥֹ */
#define INTNO_DFSDM1F0  IRQ_DFSDM1_FLT0	/* ֹ */
#define INTPRI_DFSDM1F0 -10				/* ͥ */
#define INTATR_DFSDM1F0 0				/* ° */

#define INHNO_DFSDM1F1  IRQ_DFSDM1_FLT1	/* ߥϥɥֹ */
#define INTNO_DFSDM1F1  IRQ_DFSDM1_FLT1	/* ֹ */
#define INTPRI_DFSDM1F1 -10				/* ͥ */
#define INTATR_DFSDM1F1 0				/* ° */

#define INHNO_DFSDM1F2  IRQ_DFSDM1_FLT2	/* ߥϥɥֹ */
#define INTNO_DFSDM1F2  IRQ_DFSDM1_FLT2	/* ֹ */
#define INTPRI_DFSDM1F2 -10				/* ͥ */
#define INTATR_DFSDM1F2 0				/* ° */

#define INHNO_DFSDM1F3  IRQ_DFSDM1_FLT3	/* ߥϥɥֹ */
#define INTNO_DFSDM1F3  IRQ_DFSDM1_FLT3	/* ֹ */
#define INTPRI_DFSDM1F3 -10				/* ͥ */
#define INTATR_DFSDM1F3 0				/* ° */


#define INHNO_DMAS21    IRQ_VECTOR_DMA2_STREAM1	/* ߥϥɥֹ */
#define INTNO_DMAS21    IRQ_VECTOR_DMA2_STREAM1	/* ֹ */
#define INTPRI_DMAS21   -4			/* ͥ */
#define INTATR_DMAS21   0				/* ° */

#define INHNO_DMAS23    IRQ_VECTOR_DMA2_STREAM3	/* ߥϥɥֹ */
#define INTNO_DMAS23    IRQ_VECTOR_DMA2_STREAM3	/* ֹ */
#define INTPRI_DMAS23   -4			/* ͥ */
#define INTATR_DMAS23   0				/* ° */

#define INHNO_DMAS24    IRQ_VECTOR_DMA2_STREAM4	/* ߥϥɥֹ */
#define INTNO_DMAS24    IRQ_VECTOR_DMA2_STREAM4	/* ֹ */
#define INTPRI_DMAS24   -4			/* ͥ */
#define INTATR_DMAS24   0				/* ° */

#define INHNO_DMAS26    IRQ_VECTOR_DMA2_STREAM6	/* ߥϥɥֹ */
#define INTNO_DMAS26    IRQ_VECTOR_DMA2_STREAM6	/* ֹ */
#define INTPRI_DMAS26   -4			/* ͥ */
#define INTATR_DMAS26   0				/* ° */

#define INHNO_DMAS27    IRQ_VECTOR_DMA2_STREAM7	/* ߥϥɥֹ */
#define INTNO_DMAS27    IRQ_VECTOR_DMA2_STREAM7	/* ֹ */
#define INTPRI_DMAS27   -4			/* ͥ */
#define INTATR_DMAS27   0				/* ° */

#define INHNO_USBHS   IRQ_VECTOR_OTG_HS	/* ߥϥɥֹ */
#define INTNO_USBHS   IRQ_VECTOR_OTG_HS	/* ֹ */
#define INTPRI_USBHS  -5			/* ͥ */
#define INTATR_USBHS  0				/* ° */

#define INHNO_HSWKUP  IRQ_VECTOR_OTG_HS_WKUP	/* ߥϥɥֹ */
#define INTNO_HSWKUP  IRQ_VECTOR_OTG_HS_WKUP	/* ֹ */
#define INTPRI_HSWKUP -10			/* ͥ */
#define INTATR_HSWKUP 0				/* ° */

#define NUM_USBH_EVT1   64
#define NUM_USBH_EVT2   16

#define NUM_FILENAME    256
#define NUM_FILEMAX     256
#define MAX_PATH        256
#define IMAGE_SIZE      (3*512*1024)
#define PPM_OUTSIZE     (2*1024*1024)

#define WORK_DATA_SIZE  (3*1024*1024)
#define MUSIC_DATA_SIZE (512*1024)
#define WAV_BUFFER_SIZE ((64*1024)-4)
#define SCRATCH_BUFF_SIZE   1024
#define RECORD_BUFFER_SIZE  4096

#define pHLCD           (&LcdHandle)
#define pDRAWPROP       (&DrawProp[0])

#define LCD_DEFAULT_FONT        Font24


#define BSP_TS_Init(a, b)       touchscreen_init(&TouchScreen_Handle, (a), (b), TS_ORIENTATION_LANDSCAPE)
#define BSP_TS_GetState(a)      touchscreen_getstate(&TouchScreen_Handle, (a))
#define BSP_TS_Get_GestureId(a) touchscreen_get_gestureid(&TouchScreen_Handle, (a))
#define BSP_TS_ITConfig()       0
#define BSP_TS_ResetTouchData   touchscreen_reset_data

#define TS_OK  E_OK

#define BSP_AUDIO_OUT_Init(a, b, c)     staudio_out_init(&Audio_Handle, (a), (b), (c), 128)
#define BSP_AUDIO_OUT_DeInit()          staudio_out_deinit(&Audio_Handle)
#define BSP_AUDIO_OUT_Play(a, b)        staudio_out_play(&Audio_Handle, (a), (b))
#define BSP_AUDIO_OUT_Pause()           staudio_out_pause(&Audio_Handle)
#define BSP_AUDIO_OUT_Resume()          staudio_out_resume(&Audio_Handle)
#define BSP_AUDIO_OUT_Stop(a)           staudio_out_stop(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetVolume(a)      staudio_out_setvolume(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetFrequency(a)   staudio_out_setfrequency(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetAudioFrameSlot(a) staudio_out_setframeslot(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetMute(a)        staudio_out_setmute(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetOutputMode(a)  staudio_out_setoutputmode(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_ChangeBuffer(a, b)   staudio_out_changebuffer(&Audio_Handle, (a), (b))

#define BSP_AUDIO_IN_InitEx(a, b, c, d) staudio_in_init(&Audio_Handle, (a), (b), (c), (d))
#define BSP_AUDIO_IN_DeInit()           staudio_in_deinit(&Audio_Handle)
#define BSP_AUDIO_IN_Record(a, b)       staudio_in_record(&Audio_Handle, (a), (b))
#define BSP_AUDIO_IN_Stop(a)            staudio_in_stop(&Audio_Handle, (a))
#define BSP_AUDIO_IN_Pause()            staudio_in_pause(&Audio_Handle)
#define BSP_AUDIO_IN_Resume()           staudio_in_resume(&Audio_Handle)

#define SET_BUFFER0     (1<<0)
#define SET_BUFFER1     (1<<1)
#define SET_WAV         (1<<4)
#define SET_MP3         (1<<5)
#define SET_BUFFER      (SET_BUFFER0 | SET_BUFFER1)

#define P6_HEAD_SIZE    15
#define BMP_HEAD_SIZE   54

/*
 *  disp_status
 */
#define CLOCK_APL       (1<<0)
#define MEDIA_APL       (1<<1)
#define AUDIO_APL       (1<<2)
#define JPEG_APL        (1<<3)
#define SCAN_APL        (1<<4)
#define ALL_APL         (CLOCK_APL | MEDIA_APL | AUDIO_APL | JPEG_APL | SCAN_APL)

#define MENU_SHIFT      8
#define ACTSHIFT        16
#define OPTSHIFT        24

/*
 *  ڹ¤ΤΥơ
 */
#define AUDIO_ACTIVE    (1<<0)
#define AUDIO_RECODE    (1<<1)
#define AUDIO_PHASE     (1<<4)
#define AUDIO_STOP      (1<<5)
#define AUDIO_EVENT     (1<<8)


#ifndef TOPPERS_MACRO_ONLY

typedef enum {
	AUDIO_OUT_DEVICE_SPEAKER,
	AUDIO_OUT_DEVICE_HEADPHONE,
	AUDIO_OUT_DEVICE_BOTH,
	AUDIO_OUT_DEVICE_AUTO,
	AUDIO_IN_DEVICE,
	AUDIO_IN_DEVICE_DIGITAL_MICROPHONE_1,
	AUDIO_IN_DEVICE_DIGITAL_MICROPHONE_2,
	AUDIO_IN_DEVICE_INPUT_LINE_1,
	AUDIO_IN__DEVICE_INPUT_LINE_2
} AudioDevice;

typedef enum {
	POWERDOWN_HW,
	POWERDOWN_SW
} CodecPowerDown;


/*
 *  ǥХι¤
 */
typedef struct {
	uint8_t *head;
	uint32_t csize;
	uint32_t fsize;
} MEMDEV;

#define FILE_ACT              (1<<0)
#define FILE_JPEG             (1<<1)
#define FILE_WAV              (1<<2)
#define FILE_MP3              (1<<3)
#define FILE_EXE              (FILE_JPEG | FILE_WAV | FILE_MP3)

/*
 *  ե륤ե᡼¤
 */
typedef struct {
	uint32_t devno;
	uint32_t tsize;
	uint32_t fsize;
	uint32_t num_file;
	uint32_t num_jpeg;
	struct dirent2 finfo[NUM_FILEMAX];
} FILE_INFO;

/*
 *  ڥե빽¤
 */
typedef struct {
	uint32_t       status;
	AUDIO_Handle_t *haudio;
	uint8_t        *maddr;		/* WORK BUFFER */
	uint32_t       msize;		/* WORK_BUFFER SIZE */
	uint32_t       reclength;	/* RECODE LENGTH */
	uint8_t        *pbuffer;	/* PLAY BUFFER */
	int32_t        *sbuffer;	/* SCRATCH BUFFER */
	uint16_t       *rbuffer;	/* RECODE BUFFER */
	uint8_t        *start;
	FILE           *fileid;
	uint32_t       datasize;
	uint32_t       transize;
	uint32_t       buffsize;
	uint32_t       length;
	uint32_t       playmode;
} MUSIC_INFO;

/*
 *  ž¤
 */
typedef struct _MUSIC_TRANS MUSIC_TRANS;
struct _MUSIC_TRANS {
	MUSIC_INFO     *minfo;
	int (*func)(MUSIC_TRANS*);
	uint32_t       mcount;
	uint32_t       mhead;
	uint32_t       mtail;
	uint32_t       msize;
	uint32_t       datasize;
	uint32_t       transize;
	uint32_t       musicsize;	/* MUSIC BUFFER SIZE */
	uint32_t       samplerate;
	uint32_t       channels;		/* number of channels */
};

/*
 *  WAV RIFF HEADER
 */
typedef struct {
	char     riff[4];
	uint32_t file_size;
	char     id[4];
	char     chank_fmt[4];
	uint32_t chank_size;
	uint16_t formatid;
	uint16_t channels;
	uint32_t audiofreq;
	uint32_t bytepersec;
	uint16_t blocksize;
	uint16_t bitswidth;
} Riff_Header;

/*
 *  WAV DATA HEADER
 */
typedef struct {
	char     id[4];
	uint32_t data_size;
} Data_Header;


#define BCOPY(a, b, c)  bcopy2((uint8_t *)(a), (uint8_t *)(b), c)

extern LCD_Handler_t        LcdHandle;
extern TouchScreen_Handle_t TouchScreen_Handle;
extern STAUDIO_Handle_t     Audio_Handle;
extern LCD_DrawProp_t       DrawProp[];

/*
 *  ҡΰ
 */
extern uint32_t heap_param[2];

/*
 *  ؿΥץȥ
 */
extern void	main_task(intptr_t exinf);
extern void	audio_task(intptr_t exinf);
extern void scan_task(intptr_t exinf);
extern void device_info_init(intptr_t exinf);
extern void heap_init(intptr_t exinf);
extern void sw_handle(void);

extern void BSP_AUDIO_OUT_TransferComplete_CallBack(AUDIO_Handle_t *hsai);
extern void BSP_AUDIO_OUT_HalfTransfer_CallBack(AUDIO_Handle_t *hsai);
extern void BSP_AUDIO_IN_TransferComplete_CallBack(void *handle);
extern void BSP_AUDIO_IN_HalfTransfer_CallBack(void *handle);
extern void BSP_AUDIO_OUT_Error_CallBack(void);
extern void BSP_AUDIO_IN_Error_CallBack(void);

extern void bcopy2(uint8_t *s, uint8_t *d, int len);
extern MEMDEV *setup_memory_file(FILE *st, uint8_t *addr, uint32_t size);
extern int jpeg2ppm(const char *infile, uint8_t *buffer, uint32_t size);
extern int ppm2rgb(uint8_t *rbgaddr, int *pwidth, int *pheight);

extern MUSIC_INFO *AUDIO_Hard_Init(ID id);
extern ER wav_write(MUSIC_TRANS *mtrans);
extern ER wav_player(MUSIC_TRANS *mtrans);
extern ER wav_transfar(MUSIC_TRANS *mtrans);
extern ER mp3_decode(MUSIC_TRANS *mtrans);
extern uint32_t rectransfer(MUSIC_TRANS *mtrans);

#endif /* TOPPERS_MACRO_ONLY */
