/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2018 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: aqm1248_st7565.h 2416 2018-10-17 17:56:49Z roi $
 */

/*
 *  AQM1248 ST7565 LCDץΥإåե
 */

#ifndef _AQM1248_ST7565_H_
#define _AQM1248_ST7565_H_

#ifdef __cplusplus
 extern "C" {
#endif

#include "device.h"
#include "pinmode.h"
#include "spi.h"

/*
 *  LCD顼⡼
 */
#define CM_ARGB8888         0x00000000			/* ARGB8888 color mode */
#define CM_RGB888           0x00000001			/* RGB888 color mode */
#define CM_RGB565           0x00000002			/* RGB565 color mode */

#define AQM1248_WIDTH  128
#define AQM1248_HEIGHT 48
#define AQM1248_PLINE  8

#define ST7565_COLADR  0x10
#define ST7565_RATSEL  0x20
#define ST7565_PWRSEL  0x28
#define ST7565_STRLINE 0x40
#define ST7565_SETEVOL 0x81

#define ST7565_ADCSELN 0xA0
#define ST7565_ADCSELR 0xA1
#define ST7565_BIAS19  0xA2
#define ST7565_BIAS17  0xA3
#define ST7565_ALLPNL  0xA4
#define ST7565_ALLPON  0xA5
#define ST7565_DISPNOR 0xA6
#define ST7565_DISPREV 0xA7
#define ST7565_DISPOFF 0xAE
#define ST7565_DISPON  0xAF
#define ST7565_PAGEADR 0xB0

#define ST7565_COMOUTN 0xC0
#define ST7565_COMOUTR 0xC8
#define ST7565_NOP     0xE3

// Color definitions
#define	ST7565_BLACK   0x00
#define	ST7565_BLUE    0x01
#define	ST7565_GREEN   0x02
#define ST7565_CYAN    0x03
#define	ST7565_RED     0x04
#define ST7565_MAGENTA 0x05
#define ST7565_YELLOW  0x06
#define ST7565_WHITE   0x07

#ifndef TOPPERS_MACRO_ONLY

/*
 *  LCDϥɥ鹽¤
 */
typedef struct
{
	SPI_Handle_t            *hspi;		/* spiϥɥ */
	uint16_t                _width;		/* ԥ */
	uint16_t				_height;	/* ⤵ԥ */
	uint16_t                _winx1;
	uint16_t                _winy1;
	uint16_t                _winx2;
	uint16_t                _winy2;
	ID                      spi_lock;
	uint8_t                 cs_pin;
	uint8_t                 rs_pin;
	uint8_t                 rst_pin;
	uint8_t                 lmask;
	uint8_t                 rmask;
	uint8_t                 stride;
	uint8_t                 dummy[2];
	uint8_t                 buffer[AQM1248_HEIGHT][AQM1248_WIDTH/8];
}LCD_Handler_t;

/*
 *  蹽¤
 */
typedef struct
{
	LCD_Handler_t           *hlcd;
	uint16_t                TextColor;
	uint16_t                BackColor;
	void                    *pFont;
}LCD_DrawProp_t;

typedef struct
{
	int16_t X;
	int16_t Y;
}Point, * pPoint;

/*
 *  ؿΥץȥ
 */
extern ER lcd_writecommand(LCD_Handler_t *hlcd, uint8_t c);
extern ER lcd_writedata(LCD_Handler_t *hlcd, uint8_t c);

extern void lcd_init(LCD_Handler_t *hlcd);
extern void lcd_setAddrWindow(LCD_Handler_t *hlcd, uint8_t x0, uint8_t y0, uint8_t x1, uint8_t y1);
extern void lcd_fillRect(LCD_Handler_t *hlcd, int16_t x, int16_t y, int16_t w, int16_t h, uint16_t color);
extern void lcd_pushColor(LCD_Handler_t *hlcd, uint16_t color);
extern void lcd_drawPixel(LCD_Handler_t *hlcd, int16_t x, int16_t y, uint16_t color);
extern void lcd_drawFastVLine(LCD_Handler_t *hlcd, int16_t x, int16_t y, int16_t h, uint16_t color);
extern void lcd_drawFastHLine(LCD_Handler_t *hlcd, int16_t x, int16_t y, int16_t w, uint16_t color);
extern void lcd_drawBitmap(LCD_Handler_t *hlcd, uint16_t x0, uint16_t y0, uint8_t *pbmp);
extern void lcd_invertDisplay(LCD_Handler_t *hlcd, bool_t i);

extern void lcd_fillScreen(LCD_DrawProp_t *pDrawProp);
extern void lcd_drawRect(LCD_DrawProp_t *pDrawProp, int16_t x, int16_t y, int16_t w, int16_t h);
extern void lcd_DrawCircle(LCD_DrawProp_t *pDrawProp, uint16_t x0, uint16_t y0, uint16_t Radius);
extern void lcd_drawLine(LCD_DrawProp_t *pDrawProp, uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2);
extern void lcd_drawPolygon(LCD_DrawProp_t *pDrawProp, pPoint Points, uint16_t PointCount);

#endif /* TOPPERS_MACRO_ONLY */

#ifdef __cplusplus
}
#endif

#endif	/* _AQM1248_ST7565_H_ */

