/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2019 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: BLECharacteristic.c 001 2019-02-15 18:03:17Z roi $
 */

/*
The MIT License (MIT)

Copyright (c) 2014 Sandeep Mistry

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#include <stdlib.h>
#include <utility/lib_aci.h>
#include <utility/aci_setup.h>
#include "BLECentral.h"
#include "BLECharacteristic.h"
#include "BLEPeripheral.h"

#define MIN(a, b) ((a) > (b) ? (b) : (a))

static unsigned int
convert_hex(const char a)
{
	if(a >= '0' && a <= '9')
		return a - '0';
	else if(a >= 'A' && a <= 'F')
		return a - 'A' + 10;
	else if(a >= 'a' && a <= 'f')
		return a - 'a' + 10;
	else
		return 0;
}

static int
uuid_setup(BLEUuid* puuid, const char *str)
{
  int i, len = 0;

  puuid->_str = str;
  puuid->_length = 0;
  for (i = strlen(str) - 1; i >= 0 && puuid->_length < MAX_UUID_LENGTH; i -= 2) {
    if (str[i] == '-') {
      i++;
      continue;
    }

	len = convert_hex(str[i - 1]) << 4;
	len |= convert_hex(str[i]);
	puuid->_data[puuid->_length] = len;

    puuid->_length++;
  }
  return puuid->_length;
}

/*
 *  BLEServiceåȥå
 */
void
BLEService_setup(BLEService* pserv, const char *uuid)
{
	uuid_setup(&pserv->_uuid, uuid);
	pserv->_type = BLETypeService;
}

/*
 *  BLECharacteristicåȥå
 */
void
BLECharacteristic_setup(BLECharacteristic* pcharc, const char *uuid, unsigned char properties, unsigned char *value, unsigned char len)
{
	memset(pcharc, 0, sizeof(BLECharacteristic));
	uuid_setup(&pcharc->_attr._uuid, uuid);
	pcharc->_attr._type  = BLETypeCharacteristic;
	pcharc->_properties  = properties;
	pcharc->_valueSize   = MIN(BLE_ATTRIBUTE_MAX_VALUE_LENGTH, len);
	pcharc->_value = value;
	pcharc->_valueLength = 0;
	pcharc->_fixedLength = 0;
	pcharc->_notify      = false;
	pcharc->_written     = false;
	pcharc->_subscribed  = false;
}

/*
 *  BLECharacteristic(ͤĹ)
 */
bool_t
BLECharacteristic_setValue1(BLECharacteristic *pcharc, const unsigned char value[], unsigned char length)
{
	bool_t success = true;

	if(length > pcharc->_valueSize)
		pcharc->_valueLength = pcharc->_valueSize;
	else
		pcharc->_valueLength = length;

	memcpy(pcharc->_value, value, pcharc->_valueLength);

	if(pcharc->characteristicValueChanged != NULL){
		BLEPeripheral *pblep = pcharc->_pblePeripheral;
		success = pcharc->characteristicValueChanged(&pblep->_nRF8001, pcharc);
	}
	return success;
}

/*
 *  BLECharacteristic (ͤĹʤ)
 */
bool_t
BLECharacteristic_setValue2(BLECharacteristic *pcharc, const char* value)
{
	return BLECharacteristic_setValue1(pcharc, (const unsigned char *)value, strlen(value));
}

/*
 *  BLECharacteristic ()
 */
void
BLECharacteristic_setValue(BLECharacteristic *pcharc, BLECentral* central, const unsigned char value[], unsigned char length)
{
	BLECharacteristicEventHandler eventHandler = pcharc->_eventHandlers[BLEWritten];

	BLECharacteristic_setValue1(pcharc, value, length);
	pcharc->_written = true;
	if(eventHandler != NULL)
		eventHandler(central, pcharc);
}

/*
 *  BLECharacteristic γǧ
 */
bool_t
BLECharacteristic_notified(BLECharacteristic *pcharc)
{
	bool_t notify = pcharc->_notify;

	if(notify){
		pcharc->_notify = false;
	}
	return notify;
}

/*
 *  BLECharacteristic 񤭹߳ǧ
 */
bool_t
BLECharacteristic_written(BLECharacteristic *pcharc)
{
	bool_t written = pcharc->_written;

	if(written){
		pcharc->_written = false;
	}
	return written;
}


/*
 *  BLECharacteristic Subscribed
 */
void
BLECharacteristic_setSubscribed(BLECharacteristic *pcharc, BLECentral* central, bool_t subscribed)
{
	BLECharacteristicEventHandler eventHandler = pcharc->_eventHandlers[subscribed ? BLESubscribed : BLEUnsubscribed];

	pcharc->_subscribed = subscribed;
	if(eventHandler != NULL)
		eventHandler(central, pcharc);
}

/*
 *  BLECharacteristic NotifyǽȽ
 */
bool_t
BLECharacteristic_canNotify(BLECharacteristic *pcharc)
{
	BLEPeripheral *pblep = pcharc->_pblePeripheral;
	if(pblep == NULL)
		return false;
	if(pcharc->canNotifyCharacteristic != NULL)
		return pcharc->canNotifyCharacteristic(&pblep->_nRF8001, pcharc);
	else
		return false;
}

/*
 *  BLECharacteristic IndicateǽȽ
 */
bool_t
BLECharacteristic_canIndicate(BLECharacteristic *pcharc)
{
	BLEPeripheral *pblep = pcharc->_pblePeripheral;
	if(pblep == NULL)
		return false;
	if(pcharc->canIndicateCharacteristic != NULL)
		return pcharc->canIndicateCharacteristic(&pblep->_nRF8001, pcharc);
	else
		return false;
}

/*
 *  BLECharacteristic Хåؿ
 */
void
BLECharacteristic_setEventHandler(BLECharacteristic *pcharc, uint8_t event, void *eventHandler)
{
	if(event < 3){
		pcharc->_eventHandlers[event] = eventHandler;
	}
}

