/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2018 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: BLEPeripheral.h 001 2018-10-23 17:43:24Z roi $
 */

/*
The MIT License (MIT)

Copyright (c) 2014 Sandeep Mistry

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#ifndef _BLEPERIPHERAL_H_
#define _BLEPERIPHERAL_H_

#ifdef __cplusplus
 extern "C" {
#endif

#define MAX_ATTRIBUTE       32
#define NB_BASE_SETUP_MESSAGES 7
#define NUM_DEVICE_NAME     20
#define NUM_APPEAR_VALUE    4
#define NUM_SERVICE_VALUE   4

#ifndef _BLE_ATTRIBUTE_H_
typedef struct _nRF8001 nRF8001;
#endif

enum BLEPeripheralEvent {
	BLEConnected = 0,
	BLEDisconnected = 1
};

struct pipeInfo {
	BLECharacteristic  *pcharc;

	uint16_t           valueHandle;
	uint16_t           configHandle;

	uint8_t            startPipe;
	uint8_t            txPipe;
	uint8_t            txAckPipe;
	uint8_t            rxPipe;
	uint8_t            rxAckPipe;
	uint8_t            setPipe;

	bool_t             txPipeOpen;
	bool_t             txAckPipeOpen;
};

struct _nRF8001 {
	struct aci_state_t _aciState;
	hal_aci_evt_t      _aciData;

	void*              _pblePeripheral;
	struct pipeInfo*   _pipeInfo;
	uint8_t            _numPipeInfo;
	uint16_t           _crcSeed;

	void (*nRF8001Connected)(nRF8001* nRF8001, const unsigned char* address);
	void (*nRF8001Disconnected)(nRF8001* nRF8001);
	void (*nRF8001CharacteristicValueChanged)(nRF8001* nRF8001, BLECharacteristic *pcharc, const unsigned char* value, unsigned char valueLength);
	void (*nRF8001CharacteristicSubscribedChanged)(nRF8001* nRF8001, BLECharacteristic *pcharc, bool_t subscribed);
	void (*nRF8001AddressReceived)(nRF8001* nRF8001, const unsigned char* address);
	void (*nRF8001TemperatureReceived)(nRF8001* nRF8001, float temperature);
	void (*nRF8001BatteryLevelReceived)(nRF8001* nRF8001, float batteryLevel);
};


typedef void (*BLEPeripheralEventHandler)(BLECentral* central);

typedef struct _BLEPeripheral {
	nRF8001            _nRF8001;

	const char         *_advertisedServiceUuid;
	const uint8_t      *_manufacturerData;
	uint8_t            _manufacturerDataLength;
	const char*        _localName;

	BLEAttribute*      _attributes[MAX_ATTRIBUTE];
	uint8_t            _numAttributes;

	BLECentral         _central;
	BLEPeripheralEventHandler _eventHandlers[2];
} BLEPeripheral;


extern void nRF8001_begin(nRF8001* pnRF8001, const uint8_t *advertisementData, uint8_t advertisementDataLength, const uint8_t *scanData,
                    uint8_t scanDataLength, BLEAttribute** attributes, uint8_t numAttributes);
extern bool_t nRF8001_poll(nRF8001* pnRF8001);
extern bool_t nRF8001_updateCharacteristicValue(nRF8001* pnRF8001, BLECharacteristic *pcharc);
extern bool_t nRF8001_canNotifyCharacteristic(nRF8001* pnRF8001, BLECharacteristic* pcharc);
extern bool_t nRF8001_canIndicateCharacteristic(nRF8001* pnRF8001, BLECharacteristic* pcharc);
extern void nRF8001_disconnect(nRF8001* pnRF8001);
extern void nRF8001_requestAddress(void);
extern void nRF8001_requestTemperature(void);
extern void nRF8001_requestBatteryLevel(void);
extern void nRF8001_waitForSetupMode(nRF8001* pnRF8001);
extern ER nRF8001_sendSetupMessage(nRF8001* pnRF8001, hal_aci_data_t* data);
extern void nRF8001_sendCrc(nRF8001* pnRF8001);

extern void BLEPeripheral_setup(BLEPeripheral *pblep, unsigned char req, unsigned char rdy, unsigned char rst);
extern void BLEPeripheral_begin(BLEPeripheral *pblep);
extern void BLEPeripheral_poll(BLEPeripheral *pblep);
extern void BLEPeripheral_setAdvertisedServiceUuid(BLEPeripheral *pblep, const char* advertisedServiceUuid);
extern void BLEPeripheral_setManufacturerData(BLEPeripheral *pblep, const unsigned char manufacturerData[], unsigned char manufacturerDataLength);
extern void BLEPeripheral_setLocalName(BLEPeripheral *pblep, const char* localName);
extern void BLEPeripheral_addAttribute(BLEPeripheral *pblep, BLEAttribute* attribute);
extern void BLEPeripheral_setDeviceName(BLEPeripheral *pblep, const char* deviceName);
extern void BLEPeripheral_setAppearance(BLEPeripheral *pblep, unsigned short appearance);
extern void BLEPeripheral_disconnect(BLEPeripheral *pblep);
extern BLECentral *BLEPeripheral_central(BLEPeripheral *pblep);
extern bool_t BLEPeripheral_connected(BLEPeripheral *pblep);
extern void BLEPeripheral_setEventHandler(BLEPeripheral *pblep, uint8_t event, BLEPeripheralEventHandler eventHandler);
extern bool_t BLEPeripheral_version(BLEPeripheral *pblep);
extern void BLEPeripheral_nRF8001Connected(nRF8001* nRF8001, const unsigned char* address);
extern void BLEPeripheral_nRF8001Disconnected(nRF8001* nRF8001);
extern void BLEPeripheral_nRF8001CharacteristicValueChanged(nRF8001* nRF8001, BLECharacteristic* pcharc, const unsigned char* value, unsigned char valueLength);
extern void BLEPeripheral_nRF8001CharacteristicSubscribedChanged(nRF8001* nRF8001, BLECharacteristic* pcharc, bool_t subscribed);
extern void BLEPeripheral_nRF8001AddressReceived(nRF8001* nRF8001, const unsigned char* address);
extern void BLEPeripheral_nRF8001TemperatureReceived(nRF8001* nRF8001, float temperature);
extern void BLEPeripheral_nRF8001BatteryLevelReceived(nRF8001* nRF8001, float batteryLevel);

#ifdef __cplusplus
}
#endif

#endif	/* _BLEPERIPHERAL_H_ */
