/*
 *  TOPPERS/JSP/ASP/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2017 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: stddev.c,v 1.4 2017/05/27 18:34:04 roi Exp $
 */

/* 
 *  TOPPERSѥ˥CPU¸ץࡥ
 *
 */

#include <itron.h> 
#include <stdio.h>
#include <string.h>
#include "syssvc/serial.h"
#include "monitor.h"


#ifdef _SMALL_STDIO_
/******************************************************************************
 * ̾ɸϤ
 ******************************************************************************/

FILE _iob[4];
static ID   dummyid = CONSOLE_PORTID;
static ID * stdport = &dummyid;

/*
 *  ˥Σʸʸ
 */
static int
local_getc(FILE *st)
{
	char buf[2];

	serial_rea_dat(*stdport, buf, 1);
	return (int)buf[0];
}

/*
 *  ˥ʸʸ
 */
static int
local_gets(FILE *st, unsigned int len, char *s)
{
	return serial_rea_dat(*stdport, s, len);
}

/*
 *  ˥Σʸʸ
 */
static void
local_putc(FILE *st, int c)
{
	char buf[2];

	buf[0] = c;
	serial_wri_dat(*stdport, buf, 1);
	if(c == '\n'){
		buf[0] = '\r';
		serial_wri_dat(*stdport, buf, 1);
	}
}

/*
 *  ˥ʸʸ
 */
static int
local_puts(FILE *st, unsigned int len, char *s)
{
	return serial_wri_dat(*stdport, s, len);
}

/*
 *  ˥Υǡեåʸ
 */
static int
local_flush(FILE *st)
{
	return 0;
}

/*
 *  strlen
 */
static int
local_datacount(const char *s)
{
	int i;

	for(i = 0 ; *s != 0 ; i++)
		s++;
	return i;
}

/*
 *  ɸϴؿ
 */
int fputc(int c, FILE *st)
{
	if(st == NULL)
		st = stdout;
	st->_func_out(st, c);
	return 1;
}

/*
 *  ɸʸϴؿ
 */
int fputs(const char *s, FILE *st)
{
	int status;

	if(st == NULL)
		st = stdout;
	status = st->_func_outs(st, local_datacount(s), (char *)s);
	st->_func_out(st, '\n');
	return status;
}

/*
 *  ɸϴؿ
 */
int fgetc(FILE *st)
{
	if(st == NULL)
		st = stdin;
	return st->_func_in(st);
}

/*
 *  ɸʸϴؿ
 */
int fgets(char *buf, int size, FILE *st)
{
	if(st == NULL)
		st = stdin;
	return st->_func_ins(st, size, buf);
}

/*
 *  ɸǡɤ߽Фؿ
 */
size_t fread(void *buf, size_t size, size_t count, FILE *st)
{
	int result;
	if(st == NULL)
		st = stdin;
	result = st->_func_ins(st, size*count, buf);
	return result / size;
}

/*
 *  ɸǡ񤭹ߴؿ
 */
size_t fwrite(const void *buf, size_t size, size_t count, FILE *st)
{
	int result;
	if(st == NULL)
		st = stdout;
	result = st->_func_outs(st, size*count, (char *)buf);
	return result / size;
}

/*
 *  ɸʸϴؿ
 */
int puts(const char *s)
{
	int status;

	status = stdout->_func_outs(stdout, local_datacount(s), (char *)s);
	stdout->_func_out(stdout, '\n');
	return status;
}

/*
 *  ʸϥץ
 */
int putchar(int c)
{
	return fputc(c,stdout);
}

/*
 *  ХåեΥեåؿ
 */
int fflush(FILE *st)
{
	if(st == NULL)
		st = stdout;
	return st->_func_flush(st);
}

/*
 *  ɸѥȥ꡼Фؿ
 */
FILE *_get_stdio(int no)
{
	return &_iob[no];
}

/*
 *  ɸϥȥ꡼ؿ
 */
int _set_stdio(int no)
{
	if(no >= 0 && no < 3){
		_iob[no]._file       = -1;
		_iob[no]._func_in    = (int (*)(void*))local_getc;
		_iob[no]._func_ins   = (int (*)(void*, unsigned int, char *))local_gets;
		_iob[no]._func_out   = (void (*)(void*, int))local_putc;
		_iob[no]._func_outs  = (int  (*)(void*, unsigned int, char *))local_puts;
		_iob[no]._func_flush = local_flush;
		_iob[no]._dev        = 0;
		return no;
	}
	else
		return -1;
}

/*
 *  ɸϽؿ
 */
void _setup_stdio(signed int *pport)
{
	int i;

	stdport = pport;
	for(i = 0 ; i < 3 ; i++){
		_set_stdio(i);
	}
}

#endif /* _SMALL_STDIO_ */

