/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: device.h 698 2019-03-04 18:31:14Z roi $
 */
/*
 * STM32F0XXѥǥХɥ饤Фγ
 */

#ifndef _DEVICE_H_
#define _DEVICE_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  TOPPERS BASE PLATFORM
 */
#define TOPPERS_BASE_PLATFORM_STF0

/*
 *  С
 */
#define	TPLATFORM_PRVER 0x1040		/* ץåȥեΥСֹ */

/*
 * ԥ
 */

#define PINPOSITION0    0
#define PINPOSITION1    1
#define PINPOSITION2    2
#define PINPOSITION3    3
#define PINPOSITION4    4
#define PINPOSITION5    5
#define PINPOSITION6    6
#define PINPOSITION7    7
#define PINPOSITION8    8
#define PINPOSITION9    9
#define PINPOSITION10   10
#define PINPOSITION11   11
#define PINPOSITION12   12
#define PINPOSITION13	13
#define PINPOSITION14	14
#define PINPOSITION15	15

#define GPIO_PIN_0      (1<<PINPOSITION0)
#define GPIO_PIN_1      (1<<PINPOSITION1)
#define GPIO_PIN_2      (1<<PINPOSITION2)
#define GPIO_PIN_3      (1<<PINPOSITION3)
#define GPIO_PIN_4      (1<<PINPOSITION4)
#define GPIO_PIN_5      (1<<PINPOSITION5)
#define GPIO_PIN_6      (1<<PINPOSITION6)
#define GPIO_PIN_7      (1<<PINPOSITION7)
#define GPIO_PIN_8      (1<<PINPOSITION8)
#define GPIO_PIN_9      (1<<PINPOSITION9)
#define GPIO_PIN_10     (1<<PINPOSITION10)
#define GPIO_PIN_11     (1<<PINPOSITION11)
#define GPIO_PIN_12     (1<<PINPOSITION12)
#define GPIO_PIN_13     (1<<PINPOSITION13)
#define GPIO_PIN_14     (1<<PINPOSITION14)
#define GPIO_PIN_15     (1<<PINPOSITION15)

/*
 *  GPIO⡼ɥѥ᡼
 */
#define GPIO_MODE_INPUT     0x00000000	/* Input Floating Mode */
#define GPIO_MODE_OUTPUT    0x00000001	/* Output Mode */
#define GPIO_MODE_AF        0x00000002	/* Alternate Function Mode */
#define GPIO_MODE_ANALOG    0x00000003	/* Analog Mode  */

/*
 *  GPIO-EXTI⡼ɥѥ᡼
 */
#define GPIO_MODE_IT_RISING             0x10110000	/* External Interrupt Mode with Rising edge trigger detection */
#define GPIO_MODE_IT_FALLING            0x10210000	/* External Interrupt Mode with Falling edge trigger detection */
#define GPIO_MODE_IT_RISING_FALLING     0x10310000	/* External Interrupt Mode with Rising/Falling edge trigger detection */
#define GPIO_MODE_EVT_RISING            0x10120000	/* External Event Mode with Rising edge trigger detection */
#define GPIO_MODE_EVT_FALLING           0x10220000	/* External Event Mode with Falling edge trigger detection */
#define GPIO_MODE_EVT_RISING_FALLING    0x10320000	/* External Event Mode with Rising/Falling edge trigger detection */

/*
 *  GPIOȥץåѥ᡼
 */
#define GPIO_OTYPE_PP       0x0
#define GPIO_OTYPE_OD       0x1

/*
 *  GPIOȥץåȺȿѥ᡼
 */
#define GPIO_SPEED_LOW      0x00000000	/* Low speed     */
#define GPIO_SPEED_MEDIUM   0x00000001	/* Medium speed  */
#define GPIO_SPEED_FAST     0x00000002	/* Fast speed    */
#define GPIO_SPEED_HIGH     0x00000003	/* High speed    */

/*
 *  GPIOץ륢åץѥ᡼
 */
#define GPIO_NOPULL         0x00000000	/* No Pull-up or Pull-down activation  */
#define GPIO_PULLUP         0x00000001	/* Pull-up activation                  */
#define GPIO_PULLDOWN       0x00000002	/* Pull-down activation                */

/*
 *  GPIO
 */
typedef struct
{
    uint32_t    mode;		/* specifies the operating mode for the selected pins. */
	uint32_t    pull;		/* specifies the Pull-up or Pull-Down */
	uint32_t    otype;		/* output type */
	uint32_t    speed;		/* speed for the selected pins. */
	uint32_t    alternate;	/* alternate for the selected pins. */
}GPIO_Init_t;

typedef struct {
	uint32_t    base;
	uint32_t    pinmap;
} GPIO_Init_Table;

extern void gpio_setup(uint32_t base, GPIO_Init_t *init, uint32_t pin);


/*
 *  DMAơ
 */
#define DMA_STATUS_BUSY         0x00000001	/* BUSY */
#define DMA_STATUS_READY_HMEM0  0x00000002	/* DMA Mem0 Half process success */
#define DMA_STATUS_READY_HMEM1  0x00000004	/* DMA Mem1 Half process success */
#define DMA_STATUS_READY_MEM0   0x00000008	/* DMA Mem0 process success      */
#define DMA_STATUS_READY_ERROR  0x00000100	/* DMA Error end */

/*
 *  DMA顼
 */ 
#define DMA_ERROR_NONE          0x00000000	/* No error */
#define DMA_ERROR_TE            0x00000001	/* Transfer error */
#define DMA_ERROR_FE            0x00000002	/* FIFO error */
#define DMA_ERROR_DME           0x00000004	/* Direct Mode error */
#define DMA_ERROR_TIMEOUT       0x00000020	/* Timeout error */

/*
 *  DMAꥯ
 */
#define DMA_REQUEST_0           0x00000000
#define DMA_REQUEST_1           0x00000001
#define DMA_REQUEST_2           0x00000002
#define DMA_REQUEST_3           0x00000003
#define DMA_REQUEST_4           0x00000004
#define DMA_REQUEST_5           0x00000005
#define DMA_REQUEST_6           0x00000006
#define DMA_REQUEST_7           0x00000007
#define DMA_REQUEST_8           0x00000008
#define DMA_REQUEST_9           0x00000009
#define DMA_REQUEST_10          0x0000000A
#define DMA_REQUEST_11          0x0000000B
#define DMA_REQUEST_12          0x0000000C
#define DMA_REQUEST_13          0x0000000D
#define DMA_REQUEST_14          0x0000000E
#define DMA_REQUEST_15          0x0000000F

/*
 *  DMAž
 */
#define DMA_PERIPH_TO_MEMORY    0x00000000		/* Peripheral to memory direction */
#define DMA_MEMORY_TO_PERIPH    DMA_CCR_DIR		/* Memory to peripheral direction */
#define DMA_MEMORY_TO_MEMORY    DMA_CCR_MEM2MEM	/* Memory to memory direction     */

/*
 *  DMAڥեå⡼
 */
#define DMA_PINC_ENABLE         DMA_CCR_PINC	/* Peripheral increment mode enable  */
#define DMA_PINC_DISABLE        0x00000000		/* Peripheral increment mode disable */

/*
 *  DMAå⡼
 */ 
#define DMA_MINC_ENABLE         DMA_CCR_MINC	/* Memory increment mode enable  */
#define DMA_MINC_DISABLE        0x00000000		/* Memory increment mode disable */

/*
 *  DMAڥե롦ǡ
 */
#define DMA_PDATAALIGN_BYTE     0x00000000		/* Peripheral data alignment: Byte     */
#define DMA_PDATAALIGN_HALFWORD DMA_CCR_PSIZE_0	/* Peripheral data alignment: HalfWord */
#define DMA_PDATAALIGN_WORD     DMA_CCR_PSIZE_1	/* Peripheral data alignment: Word     */

/*
 *  DMAꡦǡ
 */
#define DMA_MDATAALIGN_BYTE     0x00000000		/* Memory data alignment: Byte     */
#define DMA_MDATAALIGN_HALFWORD DMA_CCR_MSIZE_0	/* Memory data alignment: HalfWord */
#define DMA_MDATAALIGN_WORD     DMA_CCR_MSIZE_1	/* Memory data alignment: Word     */

/*
 *  DMA⡼
 */
#define DMA_NORMAL              0x00000000		/* Normal mode                  */
#define DMA_CIRCULAR            DMA_CCR_CIRC	/* Circular mode                */

/*
 *  DMAͥ٥٥
 */
#define DMA_PRIORITY_LOW        0x00000000		/* Priority level: Low       */
#define DMA_PRIORITY_MEDIUM     DMA_CCR_PL_0	/* Priority level: Medium    */
#define DMA_PRIORITY_HIGH       DMA_CCR_PL_1	/* Priority level: High      */
#define DMA_PRIORITY_VERY_HIGH  DMA_CCR_PL		/* Priority level: Very High */

/*
 *  DMA¤
 */
typedef struct
{
	uint32_t              Request;		/* Specifies the request selected for the specified channel. */
	uint32_t              Direction;	/* Specifies if the data will be transferred from memory to peripheral */
	uint32_t              PeriphInc;	/* Specifies whether the Peripheral address register should be incremented or not. */
	uint32_t              MemInc;		/* Specifies whether the memory address register should be incremented or not. */
	uint32_t              PeriphDataAlignment;	/* Specifies the Peripheral data width. */
	uint32_t              MemDataAlignment;		/* Specifies the Memory data width. */
	uint32_t              Mode;			/* Specifies the operation mode of the DMAy Streamx. */
	uint32_t              Priority;		/* Specifies the software priority for the DMAy Streamx. */
}DMA_Init_t;

/*
 *  DMAϥɥ鹽¤
 */
typedef struct __DMA_Handle_t DMA_Handle_t;
struct __DMA_Handle_t
{
	uint32_t              base;			/* DMA Port base address */
	uint32_t              cbase;		/* DMA Channel Port address */
	DMA_Init_t            Init;			/* DMA communication parameters */
	uint32_t              chid;			/* channel id */
	volatile uint32_t     status;		/* DMA status */
	void                  (*xfercallback)(DMA_Handle_t * hdma);		/* DMA transfer complete callback */
	void                  (*xferhalfcallback)(DMA_Handle_t * hdma);	/* DMA Half transfer complete callback */
	void                  (*xferm1callback)(DMA_Handle_t * hdma);	/* DMA transfer complete Memory1 callback */
	void                  (*errorcallback)(DMA_Handle_t * hdma);	/* DMA transfer error callback */
	volatile uint32_t     ErrorCode;	/* DMA Error code */
	void                  *localdata;	/* DMA local data */
};

extern ER dma_init(DMA_Handle_t *hdma);
extern ER dma_deinit(DMA_Handle_t *hdma);
extern ER dma_start(DMA_Handle_t *hdma, uint32_t SrcAddress, uint32_t DstAddress, uint32_t DataLength);
extern ER dma_end(DMA_Handle_t *hdma);
extern void dma_inthandler(DMA_Handle_t *hdma);
extern void channel_dma_isr(intptr_t exinf);


/*
 *  WINDOW-WDOGɥ饤
 */
#define WDOG1_PORTID        1
#define NUM_WDOGPORT        1

typedef struct __WDOG_Init_t
{
	uint32_t              Window;			/* WDOG Window 0x40-0x7F */
	uint32_t              Counter;			/* WDOG 󥫥 0x40-0x7F 0x7F */
	uint32_t              MCounter;			/* WDOG More Counter */
} WDOG_Init_t;

extern ER wdog_init(ID portid, WDOG_Init_t *hwini);
extern ER wdog_deinit(ID portid);
extern ER wdog_reset(ID portod);
extern void wdog_handler(void);


/*
 *  ݡȤLED³ӥå
 */
#define LEDN1           PINPOSITION5
#define LEDN2           PINPOSITION12

/*
 *  LED³ӥå
 */
#define LED01           (1<<LEDN1)
#define LED02           (1<<LEDN2)
#define LED03           0
#define LED04           0

#define LED_MASK        (LED01 | LED02 | LED03 | LED04)

/*
 *  LEDȥåξ֥ޥ
 */
#define ON              1     /* LED䥹åON             */
#define OFF             0     /* LED䥹åOFF            */

/*
 *  DIPSW
 */
#define DSW1             0x01
#define DSW2             0x02
#define DSW3             0x04
#define DSW4             0x08

/*
 *  LED³ݡȽ
 */ 
extern void led_init(intptr_t exinf);

/*
 *  LED³ݡɤ߽Ф
 */
uint_t led_in(void);

/*
 *  LED³ݡȽ񤭹
 */ 
void led_out(unsigned int led_data);

/*
 *  LEDȥåθꡦɤ߹ߴؿ
 */
extern void set_led_state(unsigned int led, unsigned char state);

#define NUM_EXTI0_FUNC   2
#define EXTI0_BASENO     0
#define NUM_EXTI2_FUNC   2
#define EXTI2_BASENO     2
#define NUM_EXTI4_FUNC   12
#define EXTI4_BASENO     4
#define INHNO_SW1  IRQ_VECTOR_EXTI4_15	/* ߥϥɥֹ */
#define INTNO_SW1  IRQ_VECTOR_EXTI4_15	/* ֹ */
#define INTPRI_SW1      -1			/* ͥ */
#define INTATR_SW1       0			/* ° */

#define EXTI_BASENO      EXTI4_BASENO
#define sw_handler       exti4_handler
#define exti_func        exti4_func

extern void (*exti0_func[NUM_EXTI0_FUNC])(void);
extern void (*exti2_func[NUM_EXTI2_FUNC])(void);
extern void (*exti4_func[NUM_EXTI4_FUNC])(void);

/*
 *  PSW³ӥå
 */
#define PSW1             0x00000001
#define PSW_MASK         (PSW1)
#define PSW_CHK_INTERVAL 10


/*
 *  PUSHå³ݡȽ
 */
extern void switch_push_init(intptr_t exinf);

/*
 *  PUSHåХåؿ
 */
extern void setup_sw_func(intptr_t exinf);

/*
 *  EXTIߥϥɥ
 */
extern void exti0_handler(void);
extern void exti2_handler(void);
extern void exti4_handler(void);

/*
 *  DIPSWμФ
 */
uint_t switch_dip_sense(void);


extern void device_info_init(intptr_t exinf);

extern uint_t dipsw_value;

#ifdef __cplusplus
}
#endif

#endif

