/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: adc.c 698 2019-01-23 22:21:40Z roi $
 */
/*
 * 
 *  ADCɥ饤дؿ(STM32G0)
 *
 */
#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include <stdio.h>
#include <string.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include <target_syssvc.h>
#include "device.h"
#include "adc.h"

/*
 *  SILؿΥޥ
 */
#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

/*
 *  ADCݡID֥åФΥޥ
 */
#define INDEX_ADC(adcid)        ((uint_t)((adcid) - 1))


#define INIT_CFGR1              (ADC_CFGR1_ALIGN | ADC_CFGR1_SCANDIR | ADC_CFGR1_EXTSEL | \
								 ADC_CFGR1_EXTEN | ADC_CFGR1_CONT    | ADC_CFGR1_DMACFG | \
								 ADC_CFGR1_OVRMOD | ADC_CFGR1_WAIT   | ADC_CFGR1_AUTOFF | ADC_CFGR1_DISCEN)

#define INIT_CFGR2              (ADC_CFGR2_LFTRIG | ADC_CFGR2_OVSE | ADC_CFGR2_OVSR | \
								 ADC_CFGR2_OVSS | ADC_CFGR2_TOVS)


#define INIT_IER                (ADC_IER_ADRDYIE | ADC_IER_EOSMPIE | ADC_IER_EOCIE | \
								 ADC_IER_EOSEQIE | ADC_IER_OVRIE   | ADC_IER_AWD1IE | \
								 ADC_IER_AWD2IE  | ADC_IER_AWD3IE  | ADC_IER_EOCALIE)

#define INIT_ISR                (ADC_ISR_ADRDY | ADC_ISR_EOSMP | ADC_ISR_EOC  | \
								 ADC_ISR_EOSEQ | ADC_ISR_OVR   | ADC_ISR_AWD1 | \
								 ADC_ISR_AWD2  | ADC_ISR_AWD3  | ADC_ISR_EOCAL)

#define ADC_CHSELR_SQ2_TO_SQ8   (ADC_CHSELR_SQ2 | ADC_CHSELR_SQ3 | ADC_CHSELR_SQ4 | \
								 ADC_CHSELR_SQ5 | ADC_CHSELR_SQ6 | ADC_CHSELR_SQ7 | ADC_CHSELR_SQ8)

#define RCC_ADCCLKSOURCE_SYSCLK       0x00000000U             /*!< SYSCLK used as ADC clock */
#define RCC_ADCCLKSOURCE_PLLADC       RCC_CCIPR_ADCSEL_0      /*!< PLL "P" (PLLADC) used as ADC clock */
#define RCC_ADCCLKSOURCE_HSI          RCC_CCIPR_ADCSEL_1      /*!< HSI used as ADC clock */

/*
 *  ADCॢȻ
 */
#define ADC_ENABLE_TIMEOUT            (10*1000)	/* 10ms */
#define ADC_DISABLE_TIMEOUT           (10*1000)	/* 10ms */
#define ADC_STOP_CONVERSION_TIMEOUT   (10*1000)	/* 10ms */

/*
 *  ADC¹Ԥ(sec)
 */
#define ADC_STAB_DELAY_US              3
/*
 *  ADC٥󥵡¹Ԥ(sec)
 */
#define ADC_TEMPSENSOR_DELAY_US        10

/*
 *  ADCݡơ֥
 */
static const ADC_PortControlBlock adc_pcb[NUM_ADCPORT] = {
  {	TADR_ADC1_BASE,
	(TADR_RCC_BASE+TOFF_RCC_APBENR2),  RCC_APBENR2_ADCEN,
	(TADR_RCC_BASE+TOFF_RCC_AHBENR),   RCC_AHBENR_DMA1EN,
	TADR_DMA1_CH1_BASE, DMA_REQUEST_ADC1 }
};

static const uint32_t channel_table[] = {
	ADC_CHANNEL_0,  ADC_CHANNEL_1,  ADC_CHANNEL_2,  ADC_CHANNEL_3,  ADC_CHANNEL_4,
	ADC_CHANNEL_5,  ADC_CHANNEL_6,  ADC_CHANNEL_7,  ADC_CHANNEL_8,  ADC_CHANNEL_9,
	ADC_CHANNEL_10, ADC_CHANNEL_11, ADC_CHANNEL_12, ADC_CHANNEL_13, ADC_CHANNEL_14,
	ADC_CHANNEL_16, ADC_CHANNEL_17, ADC_CHANNEL_18};


static ADC_Handle_t  AdcHandle[NUM_ADCPORT];

/*
 *  ADC DMAžλХåؿ
 */
static void
adc_dmatrans_func(DMA_Handle_t *hdma)
{
	ADC_Handle_t* hadc = ( ADC_Handle_t* )((DMA_Handle_t* )hdma)->localdata;

	if(hadc->Init.ContinuousConvMode == ADC_CONTINUOUS_DISABLE)
		hadc->status = ADC_STATUS_EOC;
	else
		hadc->status = ADC_STATUS_BUSY_EOC;
	if(hadc->xfercallback != NULL)
		hadc->xfercallback(hadc);
}

/*
 *  ADC DMAϡžХåؿ
 */
static void
adc_dmahalftrans_func(DMA_Handle_t *hdma)
{
	ADC_Handle_t* hadc = ( ADC_Handle_t* )((DMA_Handle_t* )hdma)->localdata;

	if(hadc->xferhalfcallback != NULL)
		hadc->xferhalfcallback(hadc);
}

/*
 *  ADC DMA顼Хåؿ
 */
static void
adc_dmaerror_func(DMA_Handle_t *hdma)
{
	ADC_Handle_t* hadc = ( ADC_Handle_t* )((DMA_Handle_t* )hdma)->localdata;

	hadc->status = ADC_STATUS_READY;
	hadc->errorcode |= ADC_ERROR_DMA;
	if(hadc->errorcallback != NULL)
		hadc->errorcallback(hadc);
}

/*
 *  ADCͭ
 */
static ER
adc_enable(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;
	uint32_t tick = 0;

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_ADEN | ADC_CR_ADDIS)) != ADC_CR_ADEN ||
			 (sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR)) & ADC_ISR_ADRDY) == 0){
		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_ADCAL | ADC_CR_ADSTP | ADC_CR_ADSTART | ADC_CR_ADDIS | ADC_CR_ADEN)) != 0){
			hadc->status = ADC_STATUS_ERROR;
			hadc->errorcode |= ADC_ERROR_INT;
			ercd = E_SYS;
		}
		else{
			/*
			 *  ADC ENABLE
			 */
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADEN);
			sil_dly_nse(ADC_STAB_DELAY_US * 1000);
			while((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR)) & ADC_ISR_ADRDY) == 0){
				if(tick > ADC_ENABLE_TIMEOUT){
					hadc->status = ADC_STATUS_ERROR;
					hadc->errorcode |= ADC_ERROR_INT;
					ercd = E_TMOUT;
					break;
				}
				tick++;
				sil_dly_nse(1000);
			}
		}
	}
	return ercd;
}

/*
 *  ADC̵
 */
static ER
adc_disable(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;
	uint32_t tick = 0;

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_ADEN | ADC_CR_ADDIS)) == ADC_CR_ADEN && 
			(sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR)) & ADC_ISR_ADRDY) != 0){
		/*
		 *  ADC DISABLE
		 */
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADDIS);
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_ADRDY | ADC_ISR_EOSMP));
		while((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADEN) != 0){
			if(tick > ADC_DISABLE_TIMEOUT){
				hadc->errorcode |= ADC_ERROR_INT;
				ercd = E_TMOUT;
			}
			tick++;
			sil_dly_nse(1000);
		}
	}
	return ercd;
}

/*
 *  ADCС
 */
static ER
adc_conversionstop(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;
	uint32_t tick = 0;

	/*
	 *  ADCС󥹥Ⱦ֤ʤԤԤ
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) != 0){
		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADDIS) == 0)
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADSTP);
		while((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) != 0){
			if(tick > ADC_STOP_CONVERSION_TIMEOUT){
				hadc->status = ADC_STATUS_ERROR;
				hadc->errorcode |= ADC_ERROR_INT;
				ercd = E_TMOUT;
				break;
			}
			tick++;
			sil_dly_nse(1000);
		}
	}
	return ercd;
}

/*
 *  ADC
 *  parameter1  port: ADCݡֹ
 *  parameter2  pini: ADC깽¤ΤؤΥݥ
 *  return ADCϥɥؤΥݥ󥿡NULLǥ顼
 */
ADC_Handle_t *
adc_init(ID portid, ADC_Init_t* pini)
{
	static DMA_Handle_t  hdma_adc;
	ADC_Handle_t *hadc;
	const ADC_PortControlBlock *apcb;

	/*
	 *  ѥ᡼å
	 */
	if(portid < 1 || portid > NUM_ADCPORT || pini == NULL)
		return NULL;

	if(pini->DiscontinuousConvMode != 0 && pini->ContinuousConvMode != 0)
		return NULL;

	hadc = &AdcHandle[INDEX_ADC(portid)];
	memcpy(&hadc->Init, pini, sizeof(ADC_Init_t));

	apcb = &adc_pcb[INDEX_ADC(portid)];
	hadc->base = apcb->base;
	hadc->apcb = apcb;

	/*
	 *  ADCå
	 */
	sil_orw_mem((uint32_t *)(apcb->adcclockbase), apcb->adcclockbit);
	sil_rew_mem((uint32_t *)(apcb->adcclockbase));

	/*
	 *  DMAбСDMAԤ
	 */
	if(apcb->dmaclockbase != 0 && pini->DMAContinuousRequests != ADC_DMACONTINUOUS_DISABLE){
		sil_orw_mem((uint32_t *)(apcb->dmaclockbase), apcb->dmaclockbit);
		sil_rew_mem((uint32_t *)(apcb->dmaclockbase));

		hdma_adc.cbase                    = apcb->dmarxchannel;
		hdma_adc.Init.Request             = apcb->dmarxrequest;
		hdma_adc.Init.Direction           = DMA_PERIPH_TO_MEMORY;
		hdma_adc.Init.PeriphInc           = DMA_PINC_DISABLE;
		hdma_adc.Init.MemInc              = DMA_MINC_ENABLE;
		hdma_adc.Init.PeriphDataAlignment = DMA_PDATAALIGN_HALFWORD;
		hdma_adc.Init.MemDataAlignment    = DMA_MDATAALIGN_HALFWORD;
		hdma_adc.Init.Mode                = DMA_CIRCULAR;
		hdma_adc.Init.Priority            = DMA_PRIORITY_MEDIUM;

		dma_init(&hdma_adc);

		hadc->hdmarx = &hdma_adc;
		hdma_adc.localdata = hadc;
	}
	else{
		hadc->hdmarx = NULL;
	}

	/*
	 *  ADCΥץꥹ()
	 */
	sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), ADC_CFGR2_CKMODE, hadc->Init.ClockPrescaler);
	if(hadc->Init.ClockPrescaler != ADC_CLOCK_SYNC_PCLK_DIV1 &&
			hadc->Init.ClockPrescaler != ADC_CLOCK_SYNC_PCLK_DIV2 &&
			hadc->Init.ClockPrescaler != ADC_CLOCK_SYNC_PCLK_DIV4){
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), ADC_CFGR2_CKMODE);
		sil_modw_mem((uint32_t *)(TADR_ADC_BASE+TOFF_ADC_CCR), ADC_CCR_PRESC, hadc->Init.ClockPrescaler);
	}

	/*
	 *  ADC
	 */
	sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR1), ADC_CFGR1_RES, hadc->Init.Resolution);

	/*
	 *  ܥơ쥮졼ͭ
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADVREGEN) == 0){
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADVREGEN);
	}

	sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR1), INIT_CFGR1, (hadc->Init.DataAlign |
							(hadc->Init.ScanConvMode & ~ADC_SCANMODE_SEQ_FIXED) |
							hadc->Init.ContinuousConvMode |
							hadc->Init.DiscontinuousConvMode | hadc->Init.DMAContinuousRequests |
							hadc->Init.Overrun | hadc->Init.LowPowerAutoWait | hadc->Init.LowPowerAutoPowerOff));

	sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), INIT_CFGR2, (hadc->Init.OversamplingMode |
							hadc->Init.OversamplingRatio | hadc->Init.OversamplingRightBitShift |
							hadc->Init.OversamplingTriggeredMode | hadc->Init.TriggerFrequencyMode));

	/*
	 *  ͥ륻쥯
	 */
	if(hadc->Init.ScanConvMode == ADC_SCANMODE_DISABLE)
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CHSELR), ADC_CHSELR_SQ2_TO_SQ8);
	else if(hadc->Init.ScanConvMode == ADC_SCANMODE_ENABLE){
		uint32_t rcount;
		for(rcount = 0 ; rcount < 8 ; rcount++){
			if(((hadc->GroupRegularSequenceRank >> (rcount * 4)) & ADC_CHSELR_SQ1) == ADC_CHSELR_SQ1)
				break;
		}
		if(rcount == 1){
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CHSELR), ADC_CHSELR_SQ2_TO_SQ8);
		}
		else{
			/*
			 *  ADC롼ץ쥮졼
			 */
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CHSELR),
                   ADC_CHSELR_SQ_ALL,
                   (ADC_CHSELR_SQ2_TO_SQ8 << (((hadc->Init.NbrOfConversion - 1) * ADC_REGULAR_RANK_2) & 0x1F)) | (hadc->GroupRegularSequenceRank));
      }
	}

	/*
	 *  ADCȥꥬ
	 */
	if(hadc->Init.ExternalTrigConv != ADC_SOFTWARE_START){
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR1), (ADC_CFGR1_EXTSEL | ADC_CFGR1_EXTEN),
			(hadc->Init.ExternalTrigConv | hadc->Init.ExternalTrigConvEdge));
	}

	/*
	 *  Сץ󥰥⡼
	 */
	if(hadc->Init.OversamplingMode != ADC_OVR_SAMPLING_DISABLE){
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), (ADC_CFGR2_OVSR | ADC_CFGR2_OVSS | ADC_CFGR2_TOVS),
			(hadc->Init.OversamplingRatio | hadc->Init.OversamplingRightBitShift | hadc->Init.OversamplingTriggeredMode));
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), ADC_CFGR2_OVSE);
	}
	else{
		/*
		 *  Сץ̵
		 */
		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2)) &ADC_CFGR2_OVSE) != 0)
			sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), ADC_CFGR2_OVSE);
	}

	/*
	 *  ץ󥰻
	 */
	sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_SMPR),
             (ADC_SMPR_SMP1 << ADC_SMPR_SMP1_BITOFFSET_POS),
             (hadc->Init.SamplingTimeCommon1 << ADC_SMPR_SMP1_BITOFFSET_POS));
	sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_SMPR),
			(ADC_SMPR_SMP1 << ADC_SMPR_SMP2_BITOFFSET_POS),
			(hadc->Init.SamplingTimeCommon2 << ADC_SMPR_SMP2_BITOFFSET_POS));

	/*
	 *  ADC֤
	 */
	hadc->errorcode = ADC_ERROR_NONE;
	hadc->status = ADC_STATUS_READY;
	return hadc;
}

/*
 *  ADCλ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return ER
 */
ER
adc_deinit(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;

	if(hadc == NULL)
		return E_PAR;

	ercd = adc_conversionstop(hadc);
	if(ercd == E_OK){
		/*
		 *  ADC̵
		 */
		ercd = adc_disable(hadc);
	}

	if(ercd == E_OK){
		/*
		 *  ꥻåIER/ISR
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), INIT_IER);
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), INIT_ISR);

		/*
		 * ꥻåȥܥơ쥮졼
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADVREGEN);

		/*
		 *  ꥻåCFGR1/CGFR2
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR1), (INIT_CFGR1 | ADC_CFGR1_AWDCH  | ADC_CFGR1_AWDEN |
															ADC_CFGR1_AWDSGL  | ADC_CFGR1_RES | ADC_CFGR1_DMAEN));
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), (ADC_CFGR2_TOVS  | ADC_CFGR2_OVSS  | ADC_CFGR2_OVSR |
															ADC_CFGR2_OVSE  | ADC_CFGR2_CKMODE));

		/*
		 *  ꥻåSMPR
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_SMPR), ADC_SMPR_SMP);

		/*
		 *  ꥻåTR1-3
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_TR1), (ADC_TR1_LT1 | ADC_TR1_HT1));
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_TR2), (ADC_TR2_LT2 | ADC_TR2_HT2));
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_TR3), (ADC_TR3_LT3 | ADC_TR3_HT3));

		/*
		 *  ꥻåCALFACT
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CALFACT), ADC_CALFACT_CALFACT);

		/*
		 *  ADCå
		 */
		sil_andw_mem((uint32_t *)(hadc->apcb->adcclockbase), hadc->apcb->adcclockbit);
	}

	/*
	 *  DMA
	 */
	if(hadc->hdmarx != NULL)
		dma_deinit(hadc->hdmarx);

	/*
	 *  ADCξֽ
	 */
	hadc->errorcode = ADC_ERROR_NONE;
	hadc->status = ADC_STATUS_RESET;
	return ercd;
}

/*
 *  ADC-ߥ⡼ɳϽ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return ER
 */
ER
adc_start_int(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;

	if(hadc == NULL)
		return E_PAR;

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) != 0)
		return E_OBJ;

    /*
	 *  ADCͭ
	 */
	if(hadc->Init.LowPowerAutoPowerOff != ADC_LOWAUTOPOWEROFF_ENABLE)
		ercd = adc_enable(hadc);

	if(ercd == E_OK){
		/*
		 *  ¹Ծ֤˰ܹ
		 */
		hadc->status = ADC_STATUS_BUSY;
		hadc->errorcode = ADC_ERROR_NONE;

		/*
		 *  ߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_EOC | ADC_ISR_EOSEQ | ADC_ISR_OVR));

		/*
		 *  ADC
		 */
		if(hadc->Init.EOCSelection == ADC_EOC_SEQ_CONV)
			sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_EOCIE);
		else
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_EOCIE);
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), (ADC_IER_EOSEQIE | ADC_IER_OVRIE));

		/*
		 *  ADC
		 */
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADSTART);
	}
	return ercd;
}

/*
 *  ADC-ߥ⡼߽
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return ER
 */
ER
adc_end_int(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;

	if(hadc == NULL)
		return E_PAR;

	/*
	 *  ADCС󥹥Ⱦ֤ʤԤԤ
	 */
	ercd = adc_conversionstop(hadc);

	/*
	 *  ADC߽
	 */
	if(ercd == E_OK){
		/*
		 *  ž顼
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), (ADC_IER_EOCIE | ADC_IER_EOSEQIE | ADC_IER_OVRIE));

		/*
		 *  ADC̵
		 */
		ercd = adc_disable(hadc);
	}
	if(ercd == E_OK)
		hadc->status = ADC_STATUS_READY;
	return ercd;
}

/*
 *  ADC-DMA⡼ɳϽ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  parameter2  pdata: ΰΥݥ
 *  parameter3  length: ǡĹ
 *  return ER
 */
ER
adc_start_dma(ADC_Handle_t* hadc, uint16_t* pdata, uint32_t length)
{
	ER ercd = E_OK;

	if(hadc == NULL)
		return E_PAR;

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) != 0)
		return E_OBJ;

    /*
	 *  ADCͭ
	 */
	if(hadc->Init.LowPowerAutoPowerOff != ADC_LOWAUTOPOWEROFF_ENABLE)
		ercd = adc_enable(hadc);

    /*
	 *  ADC-DMAȽ
	 */
    if(ercd == E_OK){
		/*
		 *  DMAХåؿ
		 */
		hadc->hdmarx->xfercallback = adc_dmatrans_func;
		hadc->hdmarx->xferhalfcallback = adc_dmahalftrans_func;
		hadc->hdmarx->errorcallback = adc_dmaerror_func;

		/*
		 *  ߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_EOC | ADC_ISR_EOSEQ | ADC_ISR_OVR));

		/*
		 *  ADCС
		 */
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_OVRIE);

		/*
		 *  ADC DMA
		 */
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR1), ADC_CFGR1_DMAEN);

		/*
		 *  ¹Ծ֤˰ܹ
		 */
		hadc->status = ADC_STATUS_BUSY;
		hadc->errorcode = ADC_ERROR_NONE;

		/*
		 *  DMA
		 */
		dma_start(hadc->hdmarx, hadc->base+TOFF_ADC_DR, (uint32_t)pdata, length);

		/*
		 *  ADC
		 */
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADSTART);
	}
	return ercd;
}

/*
 *  ADC-DMA⡼߽
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return ER
 */
ER
adc_end_dma(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;

	if(hadc == NULL)
		return E_PAR;

	/*
	 *  ADCС󥹥Ⱦ֤ʤԤԤ
	 */
	ercd = adc_conversionstop(hadc);

	/*
	 *  ADC߽
	 */
	if(ercd == E_OK){
		/*
		 *  ADCDMA⡼ɤ򥪥
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR1), ADC_CFGR1_DMAEN);

		/*
		 *  DMA
		 */
		if(hadc->hdmarx != NULL)
			ercd = dma_end(hadc->hdmarx);
		if(ercd != E_OK)
			hadc->status |= ADC_STATUS_ERROR;

		/*
		 *  Сߤ
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_OVRIE);

		/*
		 *  ADC̵
		 */
		ercd = adc_disable(hadc);
	}
	if(ercd == E_OK)
		hadc->status = ADC_STATUS_READY;
	return ercd;
}

/*
 *  ADC ߥϥɥ¹Դؿ
 */
void
adc_handler(ADC_Handle_t* hadc)
{
	uint32_t isr = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR));
	uint32_t ier = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_IER));
	uint32_t cr1 = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR1));

	if(((isr & ier) & (ADC_ISR_EOC | ADC_ISR_EOSEQ)) != 0){
	    /*
		 *  Сλ֤˰ܹ
		 */
	    if(hadc->errorcode == ADC_ERROR_NONE)
			hadc->status = ADC_STATUS_EOC;

	    /*
		 *  ADC߽
		 */
	    if((cr1 & ADC_CFGR1_EXTEN) == 0 && hadc->Init.ContinuousConvMode == ADC_CONTINUOUS_DISABLE){
		    /*
			 *  END OF SEQUENCE
			 */
		    if((isr & ADC_ISR_EOSEQ) != 0){
		        /*
				 *  EOSEQѽλADSTARTξ֤ǧ
				 */
				if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) == 0){
					/*
					 *  ߥޥ
					 */
					sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), (ADC_IER_EOCIE | ADC_IER_EOSEQIE));
					hadc->status = ADC_STATUS_BUSY_EOC;
				}
				else{	/* 󥿡ʥ륨顼 */
					hadc->status = ADC_STATUS_ERROR;
					hadc->errorcode |= ADC_ERROR_INT;
				 }
			}
		}

		/*
		 *  λХåؿɤ߽Ф
		 */
		if(hadc->xfercallback != NULL)
			hadc->xfercallback(hadc);

	    /*
		 *  ѥͭ⡼ɤǤʤгߥꥢ
		 */
	    if(hadc->Init.LowPowerAutoWait != ADC_LOWAUTOWAIT_ENABLE){
			sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_EOC | ADC_ISR_EOSEQ));
		}
	}

	/*
	 *  ʥåɥåȽ
	 */
	if((isr & ADC_ISR_AWD1) != 0 && (ier & ADC_IER_AWD1IE) != 0){
		/*
		 *  åɥåȯ֤ѹ
		 */
		hadc->status = ADC_STATUS_AWD;

		/*
		 *  åɥåߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD1);

		/*
		 *  ɥΰ襢ȤΥХåؿɤ߽Ф
		 */
		if(hadc->outofwincallback != NULL)
			hadc->outofwincallback(hadc, 1);
	}
	if((isr & ADC_ISR_AWD2) != 0 && (ier & ADC_IER_AWD2IE) != 0){
		/*
		 *  åɥåȯ֤ѹ
		 */
		hadc->status = ADC_STATUS_AWD;

		/*
		 *  åɥåߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD2);

		/*
		 *  ɥΰ襢ȤΥХåؿɤ߽Ф
		 */
		if(hadc->outofwincallback != NULL)
			hadc->outofwincallback(hadc, 2);
	}
	if((isr & ADC_ISR_AWD3) != 0 && (ier & ADC_IER_AWD3IE) != 0){
		/*
		 *  åɥåȯ֤ѹ
		 */
		hadc->status = ADC_STATUS_AWD;

		/*
		 *  åɥåߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD3);

		/*
		 *  ɥΰ襢ȤΥХåؿɤ߽Ф
		 */
		if(hadc->outofwincallback != NULL)
			hadc->outofwincallback(hadc, 3);
	}

	/*
	 *  С󥨥顼Ƚ
	 */
	if((isr & ADC_ISR_OVR) != 0 && (ier & ADC_IER_OVRIE) != 0){

		/*
		 *  Сߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_OVR);

	    /*
		 * СꡧADC_OVR_DATA_PRESERVEDޤDMAǥ顼Ԥ
		 */
	    if(hadc->Init.Overrun == ADC_OVR_DATA_PRESERVED ||
			(sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR1)) & ADC_CFGR1_DMAEN) != 0){

			/*
			 *  Сȯ֤ѹ
			 */
			hadc->status = ADC_STATUS_READY;
			hadc->errorcode |= ADC_ERROR_OVR;

			/*
			 *  顼Хåؿɤ߽Ф
			 */
			if(hadc->errorcallback != NULL)
				hadc->errorcallback(hadc);
	    }

	}
}

/*
 *  ADCߥϥɥ
 */
void
adc_int_handler(void)
{
	uint32_t i;
	ADC_Handle_t* hadc = &AdcHandle[0];

	for(i = 0 ; i < NUM_ADCPORT ; i++, hadc++){
		if(hadc->status > ADC_STATUS_RESET)
			adc_handler(hadc);
	}
}


/*
 *  쥮顼쥸μФ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return 쥮顼쥸
 */
uint32_t
adc_getvalue(ADC_Handle_t* hadc)
{
	return sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_DR));
}

/*
 *  ADCͥ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  parameter2  sConfig: ͥ깽¤ΤؤΥݥ
 *  return ER
 */
ER
adc_setupchannel(ADC_Handle_t* hadc, ADC_ChannelConf_t* sConfig)
{
	GPIO_Init_t GPIO_InitStruct;
	uint32_t clkpin, i;

	if(hadc == NULL || sConfig == NULL)
		return E_PAR;

	clkpin = (sConfig->GpioBase - TADR_GPIOA_BASE) / 0x400;
	if(clkpin >= 7 || sConfig->GpioPin >= 16)
		return E_PAR;

	/*
	 *  ͥͭ
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_IOPENR), 1<<clkpin);
	sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_IOPENR));

	GPIO_InitStruct.mode = GPIO_MODE_ANALOG;
	GPIO_InitStruct.pull = GPIO_NOPULL;
	gpio_setup(sConfig->GpioBase, &GPIO_InitStruct, sConfig->GpioPin);

	/*
	 *  
	 */
	if(sConfig->Rank != ADC_RANK_NONE){
		/*
		 *  ͥ
		 */
		if(hadc->Init.ScanConvMode == ADC_SCANMODE_SEQ_FIXED ||
				hadc->Init.ScanConvMode == ADC_SCANMODE_SEQ_FIXED_BACKWARD){
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CHSELR), (sConfig->Channel & ADC_CHSELR_CHSEL));
		}
		else{
			/*
			 *  ADC롼ץ쥮졼
			 */
			for(i = 0 ; i < (sizeof(channel_table)/4) ; i++){
				if(channel_table[i] == sConfig->Channel)
					break;
			}
			hadc->GroupRegularSequenceRank &= ~(ADC_CHSELR_SQ1 << (sConfig->Rank & 0x1F));
			hadc->GroupRegularSequenceRank |= i << (sConfig->Rank & 0x1F);

			if(((sConfig->Rank >> 2) + 1) <= hadc->Init.NbrOfConversion){
				sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CHSELR),
					(ADC_CHSELR_SQ1 << (sConfig->Rank & 0x01F)),
					((sConfig->Channel & ADC_CHSELR_SQ1) << (sConfig->Rank & 0x01F)));
			}
		}

		/*
		 *  ͥΥץ󥰻
		 */
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_SMPR),
			(sConfig->Channel << ADC_SMPR_SMPSEL0_BITOFFSET_POS),
			(sConfig->Channel << ADC_SMPR_SMPSEL0_BITOFFSET_POS) & (sConfig->SamplingTime & ADC_SAMPLING_TIME_CH_MASK));

		/*
		 *  ٥󥵡
		 */
	    if(sConfig->Channel == ADC_CHANNEL_TEMPSENSOR){
			sil_orw_mem((uint32_t *)(TADR_ADC_BASE+TOFF_ADC_CCR), ADC_CCR_TSEN);
			sil_dly_nse(ADC_TEMPSENSOR_DELAY_US*1000);
		}

		/*
		 *  VREFINTͥ
		 */
		if(sConfig->Channel == ADC_CHANNEL_VREFINT){
			sil_orw_mem((uint32_t *)(TADR_ADC_BASE+TOFF_ADC_CCR), ADC_CCR_VREFEN);
		}

		/*
		 *  VLCDͥ
		 */
		if(sConfig->Channel == ADC_CHANNEL_VLCD){
			sil_orw_mem((uint32_t *)(TADR_ADC_BASE+TOFF_ADC_CCR), ADC_CCR_VLCDEN);
		}
	}
	else{
		/*
		 *  ͥꥻå
		 */
		if(hadc->Init.ScanConvMode == ADC_SCANMODE_SEQ_FIXED ||
			hadc->Init.ScanConvMode == ADC_SCANMODE_SEQ_FIXED_BACKWARD)
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CHSELR), (sConfig->Channel & ADC_CHSELR_CHSEL));

		/*
		 *  ٥󥵡
		 */
		if(sConfig->Channel == ADC_CHANNEL_TEMPSENSOR){
			sil_andw_mem((uint32_t *)(TADR_ADC_BASE+TOFF_ADC_CCR), ADC_CCR_TSEN);
		}

		/*
		 *  VREFINTͥ
		 */
		if(sConfig->Channel == ADC_CHANNEL_VREFINT){
			sil_andw_mem((uint32_t *)(TADR_ADC_BASE+TOFF_ADC_CCR), ADC_CCR_VREFEN);
		}

		/*
		 *  VLCDͥ
		 */
		if(sConfig->Channel == ADC_CHANNEL_VREFINT){
			sil_andw_mem((uint32_t *)(TADR_ADC_BASE+TOFF_ADC_CCR), ADC_CCR_VLCDEN);
		}
	}
	return E_OK;
}

/*
 *  ADCʥåɥå
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  parameter2  AnalogWDGConfig: ʥåɥå깽¤ΤؤΥݥ
 *  return ER
 */
ER
adc_setupwatchdog(ADC_Handle_t* hadc, ADC_AnalogWDGConf_t* AnalogWDGConfig)
{
	uint32_t shift;

	if(hadc == NULL || AnalogWDGConfig == NULL)
		return E_PAR;

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) != 0)
		return E_OBJ;

	shift = ((sil_rew_mem((uint32_t *)(hadc->base+ADC_CFGR1_RES)) & ADC_CFGR1_RES) >> 3) * 2;

	/*
	 *  AWDΥ⡼, , HIGH/LOWΥåۡ
	 */
	switch(AnalogWDGConfig->WatchdogID){
	case ADC_ANALOGWATCHDOG1_ID:
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR1), (ADC_CFGR1_AWDSGL | ADC_CFGR1_AWDEN | ADC_CFGR1_AWDCH));
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR1), (AnalogWDGConfig->WatchdogMode |
									(AnalogWDGConfig->Channel & ADC_CFGR1_AWDCH)));
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD1IE, AnalogWDGConfig->ITMode);
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_TR1), ((AnalogWDGConfig->HighThreshold << (shift+16)) | (AnalogWDGConfig->LowThreshold<<shift)));
		break;
	case ADC_ANALOGWATCHDOG2_ID:
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD2CR), (ADC_CFGR1_AWDSGL | ADC_CFGR1_AWDEN | ADC_CFGR1_AWDCH));
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD2CR), (AnalogWDGConfig->WatchdogMode |
									(AnalogWDGConfig->Channel & ADC_CFGR1_AWDCH)));
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD2IE, AnalogWDGConfig->ITMode);
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_TR2), ((AnalogWDGConfig->HighThreshold << (shift+16)) | (AnalogWDGConfig->LowThreshold<<shift)));
		break;
	case ADC_ANALOGWATCHDOG3_ID:
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD3CR), (ADC_CFGR1_AWDSGL | ADC_CFGR1_AWDEN | ADC_CFGR1_AWDCH));
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD3CR), (AnalogWDGConfig->WatchdogMode |
									(AnalogWDGConfig->Channel & ADC_CFGR1_AWDCH)));
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD3IE, AnalogWDGConfig->ITMode);
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_TR3), ((AnalogWDGConfig->HighThreshold << (shift+16)) | (AnalogWDGConfig->LowThreshold<<shift)));
		break;
	default:
		break;
	}
	return E_OK;
}


