/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: adc.h 698 2019-01-23 22:22:30Z roi $
 */
/*
 * 
 *  STM32G0xx ADCǥХɥ饤Фγ
 *
 */

#ifndef _ADC_H_
#define _ADC_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  ADCݡ
 */
#define ADC1_PORTID             1
#define NUM_ADCPORT             1

/*
 *  ADCåץꥹ(ClockPrescaler)
 */
#define ADC_CLOCK_ASYNC_DIV1            0x00000000							/* ADC Asynchronous clock mode divided by 1 */
#define ADC_CLOCK_ASYNC_DIV2            ADC_CCR_PRESC_0						/* ADC Asynchronous clock mode divided by 2 */
#define ADC_CLOCK_ASYNC_DIV4            ADC_CCR_PRESC_1						/* ADC Asynchronous clock mode divided by 2 */
#define ADC_CLOCK_ASYNC_DIV6            (ADC_CCR_PRESC_1 | ADC_CCR_PRESC_0)	/* ADC Asynchronous clock mode divided by 2 */
#define ADC_CLOCK_ASYNC_DIV8            ADC_CCR_PRESC_2						/* ADC Asynchronous clock mode divided by 2 */
#define ADC_CLOCK_ASYNC_DIV10           (ADC_CCR_PRESC_2 | ADC_CCR_PRESC_0)	/* ADC Asynchronous clock mode divided by 2 */
#define ADC_CLOCK_ASYNC_DIV12           (ADC_CCR_PRESC_2 | ADC_CCR_PRESC_1)	/* ADC Asynchronous clock mode divided by 2 */
#define ADC_CLOCK_ASYNC_DIV16           (ADC_CCR_PRESC_2 | ADC_CCR_PRESC_1 | ADC_CCR_PRESC_0)	/* ADC Asynchronous clock mode divided by 2 */
#define ADC_CLOCK_ASYNC_DIV32           ADC_CCR_PRESC_3						/* ADC Asynchronous clock mode divided by 2 */
#define ADC_CLOCK_ASYNC_DIV64           (ADC_CCR_PRESC_3 | ADC_CCR_PRESC_0)	/* ADC Asynchronous clock mode divided by 2 */
#define ADC_CLOCK_ASYNC_DIV128          (ADC_CCR_PRESC_3 | ADC_CCR_PRESC_1)	/*!< ADC Asynchronous clock mode divided by 2 */
#define ADC_CLOCK_ASYNC_DIV256          (ADC_CCR_PRESC_3 | ADC_CCR_PRESC_1 | ADC_CCR_PRESC_0)	/* ADC Asynchronous clock mode divided by 2 */

#define ADC_CLOCK_SYNC_PCLK_DIV1        ADC_CFGR2_CKMODE					/* Synchronous clock mode divided by 1 */
#define ADC_CLOCK_SYNC_PCLK_DIV2        ADC_CFGR2_CKMODE_0					/* Synchronous clock mode divided by 2 */
#define ADC_CLOCK_SYNC_PCLK_DIV4        ADC_CFGR2_CKMODE_1					/* Synchronous clock mode divided by 4 */

/*
 *  ADC꥾塼(Resolution)
 */
#define ADC_RESOLUTION_12B              0x00000000
#define ADC_RESOLUTION_10B              ADC_CFGR1_RES_0
#define ADC_RESOLUTION_8B               ADC_CFGR1_RES_1
#define ADC_RESOLUTION_6B               ADC_CFGR1_RES

/*
 *  ADCǡ饤(DataAlign)
 */ 
#define ADC_DATAALIGN_RIGHT             0x00000000
#define ADC_DATAALIGN_LEFT              ADC_CFGR1_ALIGN

/*
 *  ADC󥳥С⡼(ScanConvMode)
 */
#define ADC_SCANMODE_DISABLE            0x00000000
#define ADC_SCANMODE_ENABLE             ADC_CFGR1_CHSELRMOD
#define ADC_SCANMODE_SEQ_FIXED          0x80000000                		 	/* Sequencer sense foreward */
#define ADC_SCANMODE_SEQ_FIXED_BACKWARD (0x80000000 | ADC_CFGR1_SCANDIR) 	/* Sequencer sense backward */
#define ADC_SCAN_DIRECTION_FORWARD      (ADC_SCANMODE_SEQ_FIXED)			/* For compatibility with other STM32 devices */
#define ADC_SCAN_DIRECTION_BACKWARD     (ADC_SCANMODE_SEQ_FIXED_BACKWARD)	/* For compatibility with other STM32 devices */

/*
 *  ADC EOC(EOCSelection)
 */
#define ADC_EOC_SINGLE_CONV             ADC_ISR_EOC
#define ADC_EOC_SEQ_CONV                ADC_ISR_EOS
#define ADC_EOC_SEQ_ENABLE              ADC_EOC_SINGLE_SEQ_CONV

/*
 *  ADC³⡼(ContinuousConvMode)
 */
#define ADC_CONTINUOUS_DISABLE          0x00000000
#define ADC_CONTINUOUS_ENABLE           ADC_CFGR1_CONT

/*
 *  ADC DMA(DMAContinuousRequests)
 */
#define ADC_DMACONTINUOUS_DISABLE       0x00000000
#define ADC_DMACONTINUOUS_ENABLE        ADC_CFGR1_DMACFG

/*
 *  ADC ³⡼(DiscontinuousConvMode)
 */
#define ADC_DISCONTINUOUS_DISABLE       0x00000000
#define ADC_DISCONTINUOUS_ENABLE        ADC_CFGR1_DISCEN

/*
 *  ADCȥꥬ(ExternalTrigConv)
 */
#define ADC_EXTERNALTRIGCONV_T6_TRGO    0x00000000
#define ADC_EXTERNALTRIGCONV_T21_CC2    (ADC_CFGR1_EXTSEL_0)
#define ADC_EXTERNALTRIGCONV_T2_TRGO    (ADC_CFGR1_EXTSEL_1)
#define ADC_EXTERNALTRIGCONV_T2_CC4     (ADC_CFGR1_EXTSEL_1 | ADC_CFGR1_EXTSEL_0)
#define ADC_EXTERNALTRIGCONV_T22_TRGO   (ADC_CFGR1_EXTSEL_2)
#define ADC_EXTERNALTRIGCONV_T3_TRGO    (ADC_CFGR1_EXTSEL_2 | ADC_CFGR1_EXTSEL_1)
#define ADC_EXTERNALTRIGCONV_EXT_IT11   (ADC_CFGR1_EXTSEL_2 | ADC_CFGR1_EXTSEL_1 | ADC_CFGR1_EXTSEL_0)
#define ADC_SOFTWARE_START              (ADC_CFGR1_EXTSEL + 1)

/*
 *  ADCȥꥬå(ExternalTrigConvEdge)
 */
#define ADC_EXTERNALTRIGCONVEDGE_NONE           0x00000000
#define ADC_EXTERNALTRIGCONVEDGE_RISING         ADC_CFGR1_EXTEN_0
#define ADC_EXTERNALTRIGCONVEDGE_FALLING        ADC_CFGR1_EXTEN_1
#define ADC_EXTERNALTRIGCONVEDGE_RISINGFALLING  ADC_CFGR1_EXTEN

/*
 *  ADCץ󥰻
 */
#define ADC_SAMPLETIME_1CYCLE_5         0x00000000			/* ADC sampling time 1.5 cycle */
#define ADC_SAMPLETIME_3CYCLES_5        ADC_SMPR_SMP_0		/* ADC sampling time 3.5 CYCLES */
#define ADC_SAMPLETIME_7CYCLES_5        ADC_SMPR_SMP_1		/* ADC sampling time 7.5 CYCLES */
#define ADC_SAMPLETIME_12CYCLES_5       (ADC_SMPR_SMP_1 | ADC_SMPR_SMP_0)	/* ADC sampling time 12.5 CYCLES */
#define ADC_SAMPLETIME_19CYCLES_5       ADC_SMPR_SMP_2		/* ADC sampling time 19.5 CYCLES */
#define ADC_SAMPLETIME_39CYCLES_5       (ADC_SMPR_SMP_2 | ADC_SMPR_SMP_0)	/* ADC sampling time 39.5 CYCLES */
#define ADC_SAMPLETIME_79CYCLES_5       (ADC_SMPR_SMP_2 | ADC_SMPR_SMP_1)	/* ADC sampling time 79.5 CYCLES */
#define ADC_SAMPLETIME_160CYCLES_5      ADC_SMPR_SMP		/* ADC sampling time 160.5 CYCLES */

/*
 *  ADCȥꥬ⡼
 */
#define ADC_TRIGGER_FREQ_HIGH           0x00000000			/* ADC high frequency */
#define ADC_TRIGGER_FREQ_LOW            ADC_CFGR2_LFTRIG	/* ADC low frequency */

/*
 * ADCѥȥѥ
 */
#define ADC_LOWAUTOPOWEROFF_DISABLE     0x00000000
#define ADC_LOWAUTOPOWEROFF_ENABLE      ADC_CFGR1_AUTOFF

/*
 *  ADCѥFREQUENCY
 */
#define ADC_LOWFREQUENCY_DISABLE        0x00000000
#define ADC_LOWFREQUENCY_ENABLE         ADC_CCR_LFMEN

/*
 *  ADCѥȥ
 */
#define ADC_LOWAUTOWAIT_DISABLE         0x00000000
#define ADC_LOWAUTOWAIT_ENABLE          ADC_CFGR1_WAIT

/*
 *  ADCСǡ饤ƥ
 */
#define ADC_OVR_DATA_PRESERVED          0x00000000
#define ADC_OVR_DATA_OVERWRITTEN        ADC_CFGR1_OVRMOD

/*
 *  ADCСץ󥰥⡼
 */
#define ADC_OVR_SAMPLING_DISABLE        0x00000000
#define ADC_OVR_SAMPLING_ENABLE         ADC_CFGR2_OVSE

/*
 *  ADCСץ󥰥ƥ
 */
#define ADC_OVERSAMPLING_RATIO_2        0x00000000
#define ADC_OVERSAMPLING_RATIO_4        ADC_CFGR2_OVSR_0
#define ADC_OVERSAMPLING_RATIO_8        ADC_CFGR2_OVSR_1
#define ADC_OVERSAMPLING_RATIO_16       (ADC_CFGR2_OVSR_0 | ADC_CFGR2_OVSR_1)
#define ADC_OVERSAMPLING_RATIO_32       ADC_CFGR2_OVSR_2
#define ADC_OVERSAMPLING_RATIO_64       (ADC_CFGR2_OVSR_0 | ADC_CFGR2_OVSR_2)
#define ADC_OVERSAMPLING_RATIO_128      (ADC_CFGR2_OVSR_1 | ADC_CFGR2_OVSR_2)
#define ADC_OVERSAMPLING_RATIO_256      ADC_CFGR2_OVSR

/*
 *  ADCСץ󥰥饤ȥӥåȥե
 */
#define ADC_RIGHTBITSHIFT_NONE          0x00000000
#define ADC_RIGHTBITSHIFT_1             ADC_CFGR2_OVSS_0
#define ADC_RIGHTBITSHIFT_2             ADC_CFGR2_OVSS_1
#define ADC_RIGHTBITSHIFT_3             (ADC_CFGR2_OVSS_0 | ADC_CFGR2_OVSS_1)
#define ADC_RIGHTBITSHIFT_4             ADC_CFGR2_OVSS_2
#define ADC_RIGHTBITSHIFT_5             (ADC_CFGR2_OVSS_0 | ADC_CFGR2_OVSS_2)
#define ADC_RIGHTBITSHIFT_6             (ADC_CFGR2_OVSS_1 | ADC_CFGR2_OVSS_2)
#define ADC_RIGHTBITSHIFT_7             (ADC_CFGR2_OVSS_0 | ADC_CFGR2_OVSS_1 | ADC_CFGR2_OVSS_2)
#define ADC_RIGHTBITSHIFT_8             ADC_CFGR2_OVSS_3

/*
 *  ADCСץ󥰥ȥꥬ
 */
#define ADC_TRIGGEREDMODE_SINGLE_TRIGGER    0x00000000
#define ADC_TRIGGEREDMODE_MULTI_TRIGGER     ADC_CFGR2_TOVS


/*
 *  ADCͥ
 */
#define ADC_CHANNEL_0                   ADC_CHSELR_CHSEL0
#define ADC_CHANNEL_1                   (ADC_CHSELR_CHSEL1 | ADC_CFGR1_AWDCH_0)
#define ADC_CHANNEL_2                   (ADC_CHSELR_CHSEL2 | ADC_CFGR1_AWDCH_1)
#define ADC_CHANNEL_3                   (ADC_CHSELR_CHSEL3 | ADC_CFGR1_AWDCH_1 | ADC_CFGR1_AWDCH_0)
#define ADC_CHANNEL_4                   (ADC_CHSELR_CHSEL4 | ADC_CFGR1_AWDCH_2)
#define ADC_CHANNEL_5                   (ADC_CHSELR_CHSEL5 | ADC_CFGR1_AWDCH_2| ADC_CFGR1_AWDCH_0)
#define ADC_CHANNEL_6                   (ADC_CHSELR_CHSEL6 | ADC_CFGR1_AWDCH_2| ADC_CFGR1_AWDCH_1)
#define ADC_CHANNEL_7                   (ADC_CHSELR_CHSEL7 | ADC_CFGR1_AWDCH_2| ADC_CFGR1_AWDCH_1 | ADC_CFGR1_AWDCH_0)
#define ADC_CHANNEL_8                   (ADC_CHSELR_CHSEL8 | ADC_CFGR1_AWDCH_3)
#define ADC_CHANNEL_9                   (ADC_CHSELR_CHSEL9 | ADC_CFGR1_AWDCH_3| ADC_CFGR1_AWDCH_0)
#define ADC_CHANNEL_10                  (ADC_CHSELR_CHSEL10 | ADC_CFGR1_AWDCH_3| ADC_CFGR1_AWDCH_1)
#define ADC_CHANNEL_11                  (ADC_CHSELR_CHSEL11 | ADC_CFGR1_AWDCH_3| ADC_CFGR1_AWDCH_1| ADC_CFGR1_AWDCH_0)
#define ADC_CHANNEL_12                  (ADC_CHSELR_CHSEL12 | ADC_CFGR1_AWDCH_3| ADC_CFGR1_AWDCH_2)
#define ADC_CHANNEL_13                  (ADC_CHSELR_CHSEL13 | ADC_CFGR1_AWDCH_3| ADC_CFGR1_AWDCH_2| ADC_CFGR1_AWDCH_0)
#define ADC_CHANNEL_14                  (ADC_CHSELR_CHSEL14 | ADC_CFGR1_AWDCH_3| ADC_CFGR1_AWDCH_2| ADC_CFGR1_AWDCH_1)
#define ADC_CHANNEL_15                  (ADC_CHSELR_CHSEL15 | ADC_CFGR1_AWDCH_3| ADC_CFGR1_AWDCH_2| ADC_CFGR1_AWDCH_1| ADC_CFGR1_AWDCH_0)
#define ADC_CHANNEL_16                  (ADC_CHSELR_CHSEL16 | ADC_CFGR1_AWDCH_4)
#define ADC_CHANNEL_17                  (ADC_CHSELR_CHSEL17 | ADC_CFGR1_AWDCH_4| ADC_CFGR1_AWDCH_0)
#define ADC_CHANNEL_18                  (ADC_CHSELR_CHSEL18 | ADC_CFGR1_AWDCH_4| ADC_CFGR1_AWDCH_1)

#define ADC_CHANNEL_VLCD                ADC_CHANNEL_16
#define ADC_CHANNEL_VREFINT             ADC_CHANNEL_17
#define ADC_CHANNEL_TEMPSENSOR          ADC_CHANNEL_18

/*
 *  ADCͥ
 */
#define ADC_RANK_CHANNEL_NUMBER         0x00000001	/* ͥΥͭ */
#define ADC_RANK_NONE                   0x00000002	/* ͥΥ̵ */

#define ADC_REGULAR_RANK_1              (0)		/* ADC group regular sequencer rank 1 */
#define ADC_REGULAR_RANK_2              (4)		/* ADC group regular sequencer rank 2 */
#define ADC_REGULAR_RANK_3              (8)		/* ADC group regular sequencer rank 3 */
#define ADC_REGULAR_RANK_4              (12)	/* ADC group regular sequencer rank 4 */
#define ADC_REGULAR_RANK_5              (16)	/* ADC group regular sequencer rank 5 */
#define ADC_REGULAR_RANK_6              (20)	/* ADC group regular sequencer rank 6 */
#define ADC_REGULAR_RANK_7              (24)	/* ADC group regular sequencer rank 7 */
#define ADC_REGULAR_RANK_8              (28)	/* ADC group regular sequencer rank 8 */

/*
 *  ADCץ󥰥ॳ
 */
#define ADC_CHANNEL_ID_BITFIELD_MASK    (ADC_CHSELR_CHSEL)
#define ADC_SAMPLING_TIME_CH_MASK       (ADC_CHANNEL_ID_BITFIELD_MASK << ADC_SMPR_SMPSEL0_BITOFFSET_POS)

#define ADC_SMPR_SMP1_BITOFFSET_POS     (0)	/* եȿ: "ADC_SMPR_SMP1" position in register */
#define ADC_SMPR_SMP2_BITOFFSET_POS     (4)	/* եȿ: "ADC_SMPR_SMP2" position in register */
#define ADC_SMPR_SMPSEL0_BITOFFSET_POS  (8)	/* եȿ: "ADC_SMPR_SMPSEL0" position in register */

#define ADC_SAMPLINGTIME_COMMON_1       (ADC_SMPR_SMP1_BITOFFSET_POS)	/* Set sampling time common to a group of channels: sampling time nb 1 */
#define ADC_SAMPLINGTIME_COMMON_2       (ADC_SMPR_SMP1_BITOFFSET_POS | ADC_SAMPLING_TIME_CH_MASK) /* Set sampling time common to a group of channels: sampling time nb 2 */

/*
 *  ADCʥåɥåID
 */
#define ADC_ANALOGWATCHDOG1_ID          1
#define ADC_ANALOGWATCHDOG2_ID          2
#define ADC_ANALOGWATCHDOG3_ID          3

/*
 *  ADCʥåɥå⡼
 */
#define ADC_ANALOGWATCHDOG_NONE         0x00000000
#define ADC_ANALOGWATCHDOG_SINGLE_REG   (ADC_CFGR1_AWDSGL | ADC_CFGR1_AWDEN))
#define ADC_ANALOGWATCHDOG_ALL_REG      ADC_CFGR1_AWDEN

/*
 *  ADCʥåɥåߥ⡼
 */
#define ADC_ANALOGWATCHDOG_ITMODE_DISABLE     0x00000000
#define ADC_ANALOGWATCHDOG_ITMODE_ENABLE      ADC_IER_AWDIE

/*
 *  ADCϡɥ깽¤
 */
typedef struct _ADC_PortControlBlock{
	uint32_t              base;
	uint32_t              adcclockbase;
	uint32_t              adcclockbit;
	uint32_t              dmaclockbase;
	uint32_t              dmaclockbit;
	uint32_t              dmarxchannel;
	uint32_t              dmarxrequest;
} ADC_PortControlBlock;

/*
 *  ADCν¤
 */
typedef struct
{
	uint32_t              ClockPrescaler;				/* ADCåץꥹ(ADCˤƶ) */
	uint32_t              Resolution;					/* ADCΥ꥾塼 */
	uint32_t              DataAlign;					/* ADC̥ǡ饤 */
	uint32_t              ScanConvMode;					/* ADC󥳥С⡼ */
	uint32_t              EOCSelection;					/* ADC EOC */
	uint32_t              ContinuousConvMode;			/* ADC³⡼ */
	uint32_t              NbrOfConversion;				/* ADCС */
	uint32_t              DMAContinuousRequests;		/* ADC-DMA⡼ */
	uint32_t              DiscontinuousConvMode;		/* ADC³⡼ */
	uint32_t              ExternalTrigConv;				/* ADCȥꥬ */
	uint32_t              ExternalTrigConvEdge;			/* ADCȥꥬå */
 	uint32_t              SamplingTimeCommon1;			/* ADCץ󥰻 */
 	uint32_t              SamplingTimeCommon2;			/* ADCץ󥰻 */
	uint32_t              TriggerFrequencyMode;			/* ADC trigger frequency mode. */

	uint32_t              LowPowerAutoPowerOff;			/* ADCѥȥץ󥰥 */
	uint32_t              LowPowerAutoWait;				/* ADCѥȥ */
	uint32_t              Overrun;						/* ADCDR쥸ΥС񤭹 */
	uint32_t              OversamplingMode;				/* ADCС󥵥ץ */
	uint32_t              OversamplingRatio;			/* ADCС󥵥ץ Ratio. */
	uint32_t              OversamplingRightBitShift;	/* ADCС󥵥ץ Configures the division coefficient */
	uint32_t              OversamplingTriggeredMode;	/* ADCС󥵥ץ triggered  mode. */
}ADC_Init_t;

/*
 *  ADCϥɥ鹽¤
 */ 
typedef struct __ADC_Handle_t ADC_Handle_t;
struct __ADC_Handle_t
{
	uint32_t              base;							/* ADC١ɥ쥹 */
	ADC_Init_t            Init;							/* ADCǡ */
	volatile uint32_t     GroupRegularSequenceRank;		/* ADC롼פΥ */
	DMA_Handle_t          *hdmarx;						/* ADCDMAϥɥؤΥݥ */
	const ADC_PortControlBlock  *apcb;					/* ADC PCB */
	void                  (*xfercallback)(ADC_Handle_t * hadc);		/* ADC žλХå */
	void                  (*xferhalfcallback)(ADC_Handle_t * hadc);	/* ADC ȾʬžХå */
	void                  (*outofwincallback)(ADC_Handle_t * hadc, uint8_t no);	/* ADC ʥåɥåХå */
	void                  (*errorcallback)(ADC_Handle_t * hadc);	/* ADC 顼Хå */
	volatile uint32_t     status;						/* ADCơ */
	volatile uint32_t     errorcode;					/* ADC顼 */
};

/*
 *  ͥ깽¤
 */
typedef struct
{
	uint32_t              Channel;						/* ADCֹͥ */
	uint32_t              Rank;							/* ADCֹ(1-16) */
	uint32_t              SamplingTime;					/* ADCץ󥰻 */
	uint32_t              GpioBase;						/* ADC-GPIO١ɥ쥹 */
	uint32_t              GpioPin;						/* ADC-GPIOԥֹ */
}ADC_ChannelConf_t;

/*
 *  ADCʥåɥå깽¤
 */
typedef struct
{
	uint32_t              WatchdogID;					/* ADCʥåɥåID */
	uint32_t              WatchdogMode;					/* ADCʥåɥå⡼ */
	uint32_t              HighThreshold;				/* ADCåۡɾ */
	uint32_t              LowThreshold;					/* ADCåۡɲ */
	uint32_t              Channel;						/* ADCбֹͥ */
	uint32_t              ITMode;						/* ADCʥåɥå */
}ADC_AnalogWDGConf_t;

/*
 *  ADCΥơ
 */
#define ADC_STATUS_RESET        0x00    /* ADC ̤Ѿ */
#define ADC_STATUS_READY        0x01    /* ADC ǥ */
#define ADC_STATUS_BUSY         0x02    /* ADC ӥ */
#define ADC_STATUS_EOC          0x10    /* ADC λ */
#define ADC_STATUS_BUSY_EOC     0x12    /* ADC ӥλȯ */ 
#define ADC_STATUS_AWD          0x20    /* ADC ʥåɥåȯ */
#define ADC_STATUS_ERROR		0x40	/* ADC 顼 */

/*
 *  ADC顼
 */
#define ADC_ERROR_NONE          0x00	/* No error             */
#define ADC_ERROR_OVR           0x01	/* OVR error            */
#define ADC_ERROR_DMA           0x02	/* DMA transfer error   */
#define ADC_ERROR_INT           0x04	/* INTERNAL error       */


extern ADC_Handle_t *adc_init(ID portid, ADC_Init_t *pini);
extern ER adc_deinit(ADC_Handle_t *hadc);
extern ER adc_start_int(ADC_Handle_t* hadc);
extern ER adc_end_int(ADC_Handle_t* hadc);
extern ER adc_start_dma(ADC_Handle_t* hadc, uint16_t* pdata, uint32_t length);
extern ER adc_end_dma(ADC_Handle_t* hadc);
extern ER adc_setupchannel(ADC_Handle_t* hadc, ADC_ChannelConf_t* sConfig);
extern ER adc_setupwatchdog(ADC_Handle_t* hadc, ADC_AnalogWDGConf_t* AnalogWDGConfig);
extern uint32_t adc_getvalue(ADC_Handle_t* hadc);

extern void adc_handler(ADC_Handle_t* hadc);
extern void adc_int_handler(void);

#ifdef __cplusplus
}
#endif

#endif	/* _ADC_H_ */

