/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: device.h 698 2019-03-04 18:33:06Z roi $
 */
/*
 * STM32G0XXѥǥХɥ饤Фγ
 */

#ifndef _DEVICE_H_
#define _DEVICE_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  TOPPERS BASE PLATFORM
 */
#define TOPPERS_BASE_PLATFORM_STG0

/*
 *  С
 */
#define	TPLATFORM_PRVER 0x1040		/* ץåȥեΥСֹ */

/*
 * ԥ
 */

#define PINPOSITION0    0
#define PINPOSITION1    1
#define PINPOSITION2    2
#define PINPOSITION3    3
#define PINPOSITION4    4
#define PINPOSITION5    5
#define PINPOSITION6    6
#define PINPOSITION7    7
#define PINPOSITION8    8
#define PINPOSITION9    9
#define PINPOSITION10   10
#define PINPOSITION11   11
#define PINPOSITION12   12
#define PINPOSITION13	13
#define PINPOSITION14	14
#define PINPOSITION15	15

#define GPIO_PIN_0      (1<<PINPOSITION0)
#define GPIO_PIN_1      (1<<PINPOSITION1)
#define GPIO_PIN_2      (1<<PINPOSITION2)
#define GPIO_PIN_3      (1<<PINPOSITION3)
#define GPIO_PIN_4      (1<<PINPOSITION4)
#define GPIO_PIN_5      (1<<PINPOSITION5)
#define GPIO_PIN_6      (1<<PINPOSITION6)
#define GPIO_PIN_7      (1<<PINPOSITION7)
#define GPIO_PIN_8      (1<<PINPOSITION8)
#define GPIO_PIN_9      (1<<PINPOSITION9)
#define GPIO_PIN_10     (1<<PINPOSITION10)
#define GPIO_PIN_11     (1<<PINPOSITION11)
#define GPIO_PIN_12     (1<<PINPOSITION12)
#define GPIO_PIN_13     (1<<PINPOSITION13)
#define GPIO_PIN_14     (1<<PINPOSITION14)
#define GPIO_PIN_15     (1<<PINPOSITION15)

/*
 *  GPIO⡼ɥѥ᡼
 */
#define GPIO_MODE_INPUT     0x00000000	/* Input Floating Mode */
#define GPIO_MODE_OUTPUT    0x00000001	/* Output Mode */
#define GPIO_MODE_AF        0x00000002	/* Alternate Function Mode */
#define GPIO_MODE_ANALOG    0x00000003	/* Analog Mode  */

/*
 *  GPIO-EXTI⡼ɥѥ᡼
 */
#define GPIO_MODE_IT_RISING             0x10110000	/* External Interrupt Mode with Rising edge trigger detection */
#define GPIO_MODE_IT_FALLING            0x10210000	/* External Interrupt Mode with Falling edge trigger detection */
#define GPIO_MODE_IT_RISING_FALLING     0x10310000	/* External Interrupt Mode with Rising/Falling edge trigger detection */
#define GPIO_MODE_EVT_RISING            0x10120000	/* External Event Mode with Rising edge trigger detection */
#define GPIO_MODE_EVT_FALLING           0x10220000	/* External Event Mode with Falling edge trigger detection */
#define GPIO_MODE_EVT_RISING_FALLING    0x10320000	/* External Event Mode with Rising/Falling edge trigger detection */

/*
 *  GPIOȥץåѥ᡼
 */
#define GPIO_OTYPE_PP       0x0
#define GPIO_OTYPE_OD       0x1

/*
 *  GPIOȥץåȺȿѥ᡼
 */
#define GPIO_SPEED_LOW      0x00000000	/* Low speed     */
#define GPIO_SPEED_MEDIUM   0x00000001	/* Medium speed  */
#define GPIO_SPEED_FAST     0x00000002	/* Fast speed    */
#define GPIO_SPEED_HIGH     0x00000003	/* High speed    */

/*
 *  GPIOץ륢åץѥ᡼
 */
#define GPIO_NOPULL         0x00000000	/* No Pull-up or Pull-down activation  */
#define GPIO_PULLUP         0x00000001	/* Pull-up activation                  */
#define GPIO_PULLDOWN       0x00000002	/* Pull-down activation                */

/*
 *  GPIO
 */
typedef struct
{
    uint32_t    mode;		/* specifies the operating mode for the selected pins. */
	uint32_t    pull;		/* specifies the Pull-up or Pull-Down */
	uint32_t    otype;		/* output type */
	uint32_t    speed;		/* speed for the selected pins. */
	uint32_t    alternate;	/* alternate for the selected pins. */
}GPIO_Init_t;

typedef struct {
	uint32_t    base;
	uint32_t    pinmap;
} GPIO_Init_Table;


extern void gpio_setup(uint32_t base, GPIO_Init_t *init, uint32_t pin);

/*
 *  SYSCLOCK
 */
#define SYSCLOCK_MSI    (RCC_CFGR_SWS_MSI >> 2)
#define SYSCLOCK_HSI    (RCC_CFGR_SWS_HSI >> 2)
#define SYSCLOCK_HSE    (RCC_CFGR_SWS_HSE >> 2)
#define SYSCLOCK_PLL    (RCC_CFGR_SWS_PLL >> 2)

/*
 *  ƥ९å֤
 */
extern uint32_t get_sysclock(uint8_t *sws);


/*
 *  DMAơ
 */
#define DMA_STATUS_BUSY         0x00000001	/* BUSY */
#define DMA_STATUS_READY_HMEM0  0x00000002	/* DMA Mem0 Half process success */
#define DMA_STATUS_READY_HMEM1  0x00000004	/* DMA Mem1 Half process success */
#define DMA_STATUS_READY_MEM0   0x00000008	/* DMA Mem0 process success      */
#define DMA_STATUS_READY_ERROR  0x00000100	/* DMA Error end */

/*
 *  DMA顼
 */ 
#define DMA_ERROR_NONE          0x00000000	/* No error */
#define DMA_ERROR_TE            0x00000001	/* Transfer error */
#define DMA_ERROR_FE            0x00000002	/* FIFO error */
#define DMA_ERROR_DME           0x00000004	/* Direct Mode error */
#define DMA_ERROR_TIMEOUT       0x00000020	/* Timeout error */

/*
 *  DMAꥯ
 */
#define DMA_REQUEST_MEM2MEM     0	/* memory to memory transfer */
#define DMA_REQUEST_GENERATOR0  1	/* DMAMUX1 request generator 0 */
#define DMA_REQUEST_GENERATOR1  2	/* DMAMUX1 request generator 1 */
#define DMA_REQUEST_GENERATOR2	3	/* DMAMUX1 request generator 2 */
#define DMA_REQUEST_GENERATOR3  4	/* DMAMUX1 request generator 3 */

#define DMA_REQUEST_ADC1        5	/* DMAMUX1 ADC1 request */
#define DMA_REQUEST_AES_IN      6	/* DMAMUX AES IN request */
#define DMA_REQUEST_AES_OUT     7	/* DMAMUX AES OUT request */
#define DMA_REQUEST_DAC1_CH1    8	/* DMAMUX SPI2 RX request */
#define DMA_REQUEST_DAC1_CH2    9	/* DMAMUX SPI2 TX request */
#define DMA_REQUEST_I2C1_RX     10	/* DMAMUX I2C1 RX request */
#define DMA_REQUEST_I2C1_TX     11	/* DMAMUX I2C1 TX request */
#define DMA_REQUEST_I2C2_RX     12	/* DMAMUX I2C2 RX request */
#define DMA_REQUEST_I2C2_TX     13	/* DMAMUX I2C2 TX request */
#define DMA_REQUEST_LPUART1_RX  14	/* DMAMUX LPUART1 RX request */
#define DMA_REQUEST_LPUART1_TX  15	/* DMAMUX LPUART1 TX request */
#define DMA_REQUEST_SPI1_RX     16	/* DMAMUX SPI1 RX request */
#define DMA_REQUEST_SPI1_TX     17	/* DMAMUX SPI1 TX request */
#define DMA_REQUEST_SPI2_RX     18	/* DMAMUX SPI2 RX request */
#define DMA_REQUEST_SPI2_TX     19	/* DMAMUX SPI2 TX request */
#define DMA_REQUEST_TIM1_CH1    20	/* DMAMUX TIM1 CH1 request */
#define DMA_REQUEST_TIM1_CH2    21	/* DMAMUX TIM1 CH2 request */
#define DMA_REQUEST_TIM1_CH3    22	/* DMAMUX TIM1 CH3 request */
#define DMA_REQUEST_TIM1_CH4    23	/* DMAMUX TIM1 CH4 request */
#define DMA_REQUEST_TIM1_TRIG_COM 24	/* DMAMUX TIM1 TRIG COM request  */
#define DMA_REQUEST_TIM1_UP     25	/* DMAMUX TIM1 UP request */
#define DMA_REQUEST_TIM2_CH1    26	/* DMAMUX TIM2 CH1 request */
#define DMA_REQUEST_TIM2_CH2    27	/* DMAMUX TIM2 CH2 request */
#define DMA_REQUEST_TIM2_CH3    28	/* DMAMUX TIM2 CH3 request */
#define DMA_REQUEST_TIM2_CH4    29	/* DMAMUX TIM2 CH4 request */
#define DMA_REQUEST_TIM2_TRIG   30	/* DMAMUX TIM2 TRIG request */
#define DMA_REQUEST_TIM2_UP     31	/* DMAMUX TIM2 UP request */
#define DMA_REQUEST_TIM3_CH1    32	/* DMAMUX TIM3 CH1 request */
#define DMA_REQUEST_TIM3_CH2    33	/* DMAMUX TIM3 CH2 request */
#define DMA_REQUEST_TIM3_CH3    34	/* DMAMUX TIM3 CH3 request */
#define DMA_REQUEST_TIM3_CH4    35	/* DMAMUX TIM3 CH4 request */
#define DMA_REQUEST_TIM3_TRIG   36	/* DMAMUX TIM3 TRIG request */
#define DMA_REQUEST_TIM3_UP     37	/* DMAMUX TIM3 UP request */
#define DMA_REQUEST_TIM6_UP     38	/* DMAMUX TIM6 UP request */
#define DMA_REQUEST_TIM7_UP     39	/* DMAMUX TIM7 UP request */
#define DMA_REQUEST_TIM15_CH1   40	/* DMAMUX TIM15 CH1 request */
#define DMA_REQUEST_TIM15_CH2   41	/* DMAMUX TIM15 CH2 request */
#define DMA_REQUEST_TIM15_TRIG_COM 42	/* DMAMUX TIM15 TRIG COM request */
#define DMA_REQUEST_TIM15_UP    43	/* DMAMUX TIM15 UP request */
#define DMA_REQUEST_TIM16_CH1   44	/* DMAMUX TIM16 CH1 request */
#define DMA_REQUEST_TIM16_TRIG_COM 45	/* DMAMUX TIM16 TRIG COM request */
#define DMA_REQUEST_TIM16_UP    46	/* DMAMUX TIM16 UP request */
#define DMA_REQUEST_TIM17_CH1   47	/* DMAMUX TIM17 CH2 request */
#define DMA_REQUEST_TIM17_TRIG_COM 48	/* DMAMUX TIM17 TRIG COM request */
#define DMA_REQUEST_TIM17_UP    49	/* DMAMUX TIM17 UP request */
#define DMA_REQUEST_USART1_RX   50	/* DMAMUX USART1 RX request */
#define DMA_REQUEST_USART1_TX   51	/* DMAMUX USART1 TX request */
#define DMA_REQUEST_USART2_RX   52	/* DMAMUX USART2 RX request */
#define DMA_REQUEST_USART2_TX   53	/* DMAMUX USART2 TX request */
#define DMA_REQUEST_USART3_RX   54	/* DMAMUX USART3 RX request */
#define DMA_REQUEST_USART3_TX   55	/* DMAMUX USART3 TX request */
#define DMA_REQUEST_USART4_RX   56	/* DMAMUX USART4 RX request */
#define DMA_REQUEST_USART4_TX   57	/* DMAMUX USART4 TX request */
#define DMA_REQUEST_UCPD1_RX    58	/* DMAMUX UCPD1 RX request */
#define DMA_REQUEST_UCPD1_TX    59	/* DMAMUX UCPD1 TX request */
#define DMA_REQUEST_UCPD2_RX    60	/* DMAMUX UCPD2 RX request */
#define DMA_REQUEST_UCPD2_TX    61	/* DMAMUX UCPD2 TX request */

/*
 *  쥬
 */
#define DMA_REQUEST_0           DMA_REQUEST_ADC1

/*
 *  DMAž
 */
#define DMA_PERIPH_TO_MEMORY    0x00000000		/* Peripheral to memory direction */
#define DMA_MEMORY_TO_PERIPH    DMA_CCR_DIR		/* Memory to peripheral direction */
#define DMA_MEMORY_TO_MEMORY    DMA_CCR_MEM2MEM	/* Memory to memory direction     */

/*
 *  DMAڥեå⡼
 */
#define DMA_PINC_ENABLE         DMA_CCR_PINC	/* Peripheral increment mode enable  */
#define DMA_PINC_DISABLE        0x00000000		/* Peripheral increment mode disable */

/*
 *  DMAå⡼
 */ 
#define DMA_MINC_ENABLE         DMA_CCR_MINC	/* Memory increment mode enable  */
#define DMA_MINC_DISABLE        0x00000000		/* Memory increment mode disable */

/*
 *  DMAڥե롦ǡ
 */
#define DMA_PDATAALIGN_BYTE     0x00000000		/* Peripheral data alignment: Byte     */
#define DMA_PDATAALIGN_HALFWORD DMA_CCR_PSIZE_0	/* Peripheral data alignment: HalfWord */
#define DMA_PDATAALIGN_WORD     DMA_CCR_PSIZE_1	/* Peripheral data alignment: Word     */

/*
 *  DMAꡦǡ
 */
#define DMA_MDATAALIGN_BYTE     0x00000000		/* Memory data alignment: Byte     */
#define DMA_MDATAALIGN_HALFWORD DMA_CCR_MSIZE_0	/* Memory data alignment: HalfWord */
#define DMA_MDATAALIGN_WORD     DMA_CCR_MSIZE_1	/* Memory data alignment: Word     */

/*
 *  DMA⡼
 */
#define DMA_NORMAL              0x00000000		/* Normal mode                  */
#define DMA_CIRCULAR            DMA_CCR_CIRC	/* Circular mode                */

/*
 *  DMAͥ٥٥
 */
#define DMA_PRIORITY_LOW        0x00000000		/* Priority level: Low       */
#define DMA_PRIORITY_MEDIUM     DMA_CCR_PL_0	/* Priority level: Medium    */
#define DMA_PRIORITY_HIGH       DMA_CCR_PL_1	/* Priority level: High      */
#define DMA_PRIORITY_VERY_HIGH  DMA_CCR_PL		/* Priority level: Very High */

/*
 *  DMA¤
 */
typedef struct
{
	uint32_t              Request;		/* Specifies the request selected for the specified channel. */
	uint32_t              Direction;	/* Specifies if the data will be transferred from memory to peripheral */
	uint32_t              PeriphInc;	/* Specifies whether the Peripheral address register should be incremented or not. */
	uint32_t              MemInc;		/* Specifies whether the memory address register should be incremented or not. */
	uint32_t              PeriphDataAlignment;	/* Specifies the Peripheral data width. */
	uint32_t              MemDataAlignment;		/* Specifies the Memory data width. */
	uint32_t              Mode;			/* Specifies the operation mode of the DMAy Streamx. */
	uint32_t              Priority;		/* Specifies the software priority for the DMAy Streamx. */
}DMA_Init_t;

/*
 *  DMAϥɥ鹽¤
 */
typedef struct __DMA_Handle_t DMA_Handle_t;
struct __DMA_Handle_t
{
	uint32_t              base;			/* DMA Port base address */
	uint32_t              cbase;		/* DMA Channel Port address */
	DMA_Init_t            Init;			/* DMA communication parameters */
	uint8_t               chid;			/* channel id */
	uint8_t               chid2;		/* channel id2 */
	uint8_t               chnum;		/* channel number */
	int8_t                genreqno;		/* request GEN number */
	volatile uint32_t     status;		/* DMA status */
	void                  (*xfercallback)(DMA_Handle_t * hdma);		/* DMA transfer complete callback */
	void                  (*xferhalfcallback)(DMA_Handle_t * hdma);	/* DMA Half transfer complete callback */
	void                  (*xferm1callback)(DMA_Handle_t * hdma);	/* DMA transfer complete Memory1 callback */
	void                  (*errorcallback)(DMA_Handle_t * hdma);	/* DMA transfer error callback */
	volatile uint32_t     ErrorCode;	/* DMA Error code */
	void                  *localdata;	/* DMA local data */
};

extern ER dma_init(DMA_Handle_t *hdma);
extern ER dma_deinit(DMA_Handle_t *hdma);
extern ER dma_start(DMA_Handle_t *hdma, uint32_t SrcAddress, uint32_t DstAddress, uint32_t DataLength);
extern ER dma_end(DMA_Handle_t *hdma);
extern void dma_inthandler(DMA_Handle_t *hdma);
extern void channel_dma_isr(intptr_t exinf);


/*
 *  WINDOW-WDOGɥ饤
 */
#define WDOG1_PORTID        1
#define NUM_WDOGPORT        1

typedef struct __WDOG_Init_t
{
	uint32_t              Window;			/* WDOG Window 0x40-0x7F */
	uint32_t              Counter;			/* WDOG 󥫥 0x40-0x7F 0x7F */
	uint32_t              MCounter;			/* WDOG More Counter */
} WDOG_Init_t;

extern ER wdog_init(ID portid, WDOG_Init_t *hwini);
extern ER wdog_deinit(ID portid);
extern ER wdog_reset(ID portod);
extern void wdog_handler(void);


/*
 *  LED³ӥå
 */
#define LED01           (1<<0)
#define LED02           (1<<1)
#define LED03           (1<<2)
#define LED04           (1<<3)

#define LED_MASK        (LED01 | LED02 | LED03 | LED04)

/*
 *  LEDȥåξ֥ޥ
 */
#define ON              1     /* LED䥹åON             */
#define OFF             0     /* LED䥹åOFF            */

/*
 *  DIPSW
 */
#define DSW1             0x01
#define DSW2             0x02
#define DSW3             0x04
#define DSW4             0x08

/*
 *  LED³ݡȽ
 */ 
extern void led_init(intptr_t exinf);

/*
 *  LED³ݡɤ߽Ф
 */
uint_t led_in(void);

/*
 *  LED³ݡȽ񤭹
 */ 
void led_out(unsigned int led_data);

/*
 *  LEDȥåθꡦɤ߹ߴؿ
 */
extern void set_led_state(unsigned int led, unsigned char state);

#define NUM_EXTI0_FUNC   2
#define EXTI0_BASENO     0
#define EXTI0_MASK       0x00000003
#define NUM_EXTI2_FUNC   2
#define EXTI2_BASENO     2
#define NUM_EXTI4_FUNC   12
#define EXTI2_MASK       0x0000000C
#define EXTI4_BASENO     4
#define NUM_EXTI_FUNC    16
#define EXTI4_MASK       0x0000FFF0

#define INTPRI_SW1      -1			/* ͥ */
#define INTATR_SW1       0			/* ° */

#define INHNO_SW1  IRQ_VECTOR_EXTI4_15	/* ߥϥɥֹ */
#define INTNO_SW1  IRQ_VECTOR_EXTI4_15	/* ֹ */
#define sw_handler       exti4_handler

extern void (*exti_func[NUM_EXTI_FUNC])(void);

/*
 *  PSW³ӥå
 */
#define PSW1             0x00000001
#define PSW_MASK         (PSW1)
#define PSW_CHK_INTERVAL 10


/*
 *  PUSHå³ݡȽ
 */
extern void switch_push_init(intptr_t exinf);

/*
 *  PUSHåХåؿ
 */
extern void setup_sw_func(intptr_t exinf);

/*
 *  EXTIߥϥɥ
 */
extern void exti0_handler(void);
extern void exti2_handler(void);
extern void exti4_handler(void);

/*
 *  DIPSWμФ
 */
uint_t switch_dip_sense(void);


extern void device_info_init(intptr_t exinf);

extern uint_t dipsw_value;

#ifdef __cplusplus
}
#endif

#endif

