/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: device.h 699 2019-03-04 18:33:58Z roi $
 */
/*
 * STM32L4XXѥǥХɥ饤Фγ
 */

#ifndef _DEVICE_H_
#define _DEVICE_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  TOPPERS BASE PLATFORM
 */
#define TOPPERS_BASE_PLATFORM_STL4

/*
 *  С
 */
#define	TPLATFORM_PRVER 0x1040		/* ץåȥեΥСֹ */

/*
 * ԥ
 */

#define PINPOSITION0    0
#define PINPOSITION1    1
#define PINPOSITION2    2
#define PINPOSITION3    3
#define PINPOSITION4    4
#define PINPOSITION5    5
#define PINPOSITION6    6
#define PINPOSITION7    7
#define PINPOSITION8    8
#define PINPOSITION9    9
#define PINPOSITION10   10
#define PINPOSITION11   11
#define PINPOSITION12   12
#define PINPOSITION13	13
#define PINPOSITION14	14
#define PINPOSITION15	15

#define GPIO_PIN_0      (1<<PINPOSITION0)
#define GPIO_PIN_1      (1<<PINPOSITION1)
#define GPIO_PIN_2      (1<<PINPOSITION2)
#define GPIO_PIN_3      (1<<PINPOSITION3)
#define GPIO_PIN_4      (1<<PINPOSITION4)
#define GPIO_PIN_5      (1<<PINPOSITION5)
#define GPIO_PIN_6      (1<<PINPOSITION6)
#define GPIO_PIN_7      (1<<PINPOSITION7)
#define GPIO_PIN_8      (1<<PINPOSITION8)
#define GPIO_PIN_9      (1<<PINPOSITION9)
#define GPIO_PIN_10     (1<<PINPOSITION10)
#define GPIO_PIN_11     (1<<PINPOSITION11)
#define GPIO_PIN_12     (1<<PINPOSITION12)
#define GPIO_PIN_13     (1<<PINPOSITION13)
#define GPIO_PIN_14     (1<<PINPOSITION14)
#define GPIO_PIN_15     (1<<PINPOSITION15)

/*
 *  GPIO⡼ɥѥ᡼
 */
#define GPIO_MODE_INPUT     0x00000000	/* Input Floating Mode */
#define GPIO_MODE_OUTPUT    0x00000001	/* Output Mode */
#define GPIO_MODE_AF        0x00000002	/* Alternate Function Mode */
#define GPIO_MODE_ANALOG    0x00000003	/* Analog Mode  */
#define GPIO_MODE_ANALOG_AD 0x00000007	/* Analog ADC Mode  */

/*
 *  GPIO-EXTI⡼ɥѥ᡼
 */
#define GPIO_MODE_IT_RISING             0x10110000	/* External Interrupt Mode with Rising edge trigger detection */
#define GPIO_MODE_IT_FALLING            0x10210000	/* External Interrupt Mode with Falling edge trigger detection */
#define GPIO_MODE_IT_RISING_FALLING     0x10310000	/* External Interrupt Mode with Rising/Falling edge trigger detection */
#define GPIO_MODE_EVT_RISING            0x10120000	/* External Event Mode with Rising edge trigger detection */
#define GPIO_MODE_EVT_FALLING           0x10220000	/* External Event Mode with Falling edge trigger detection */
#define GPIO_MODE_EVT_RISING_FALLING    0x10320000	/* External Event Mode with Rising/Falling edge trigger detection */

/*
 *  GPIOȥץåѥ᡼
 */
#define GPIO_OTYPE_PP       0x0
#define GPIO_OTYPE_OD       0x1

/*
 *  GPIOȥץåȺȿѥ᡼
 */
#define GPIO_SPEED_LOW      0x00000000	/* Low speed     */
#define GPIO_SPEED_MEDIUM   0x00000001	/* Medium speed  */
#define GPIO_SPEED_FAST     0x00000002	/* Fast speed    */
#define GPIO_SPEED_HIGH     0x00000003	/* High speed    */

/*
 *  GPIOץ륢åץѥ᡼
 */
#define GPIO_NOPULL         0x00000000	/* No Pull-up or Pull-down activation  */
#define GPIO_PULLUP         0x00000001	/* Pull-up activation                  */
#define GPIO_PULLDOWN       0x00000002	/* Pull-down activation                */

/*
 *  GPIO
 */
typedef struct
{
    uint32_t    mode;		/* specifies the operating mode for the selected pins. */
	uint32_t    pull;		/* specifies the Pull-up or Pull-Down */
	uint32_t    otype;		/* output type */
	uint32_t    speed;		/* speed for the selected pins. */
	uint32_t    alternate;	/* alternate for the selected pins. */
}GPIO_Init_t;

typedef struct {
	uint32_t    base;
	uint32_t    pinmap;
} GPIO_Init_Table;


extern void gpio_setup(uint32_t base, GPIO_Init_t *init, uint32_t pin);

/*
 *  SYSCLOCK
 */
#define SYSCLOCK_MSI    (RCC_CFGR_SWS_MSI >> 2)
#define SYSCLOCK_HSI    (RCC_CFGR_SWS_HSI >> 2)
#define SYSCLOCK_HSE    (RCC_CFGR_SWS_HSE >> 2)
#define SYSCLOCK_PLL    (RCC_CFGR_SWS_PLL >> 2)

/*
 *  ƥ९å֤
 */
extern uint32_t get_sysclock(uint8_t *sws);


/*
 *  DMAͥID
 */
#define DMA1CH1_ID              (0)
#define DMA1CH2_ID              (1)
#define DMA1CH3_ID              (2)
#define DMA1CH4_ID              (3)
#define DMA1CH5_ID              (4)
#define DMA1CH6_ID              (5)
#define DMA1CH7_ID              (6)
#define DMA2CH1_ID              (7+0)
#define DMA2CH2_ID              (7+1)
#define DMA2CH3_ID              (7+2)
#define DMA2CH4_ID              (7+3)
#define DMA2CH5_ID              (7+4)
#define DMA2CH6_ID              (7+5)
#define DMA2CH7_ID              (7+6)

/*
 *  DMAơ
 */
#define DMA_STATUS_BUSY         0x00000001	/* BUSY */
#define DMA_STATUS_READY_HMEM0  0x00000002	/* DMA Mem0 Half process success */
#define DMA_STATUS_READY_HMEM1  0x00000004	/* DMA Mem1 Half process success */
#define DMA_STATUS_READY_MEM0   0x00000008	/* DMA Mem0 process success      */
#define DMA_STATUS_READY_ERROR  0x00000100	/* DMA Error end */

/*
 *  DMA顼
 */ 
#define DMA_ERROR_NONE          0x00000000	/* No error */
#define DMA_ERROR_TE            0x00000001	/* Transfer error */
#define DMA_ERROR_FE            0x00000002	/* FIFO error */
#define DMA_ERROR_DME           0x00000004	/* Direct Mode error */
#define DMA_ERROR_TIMEOUT       0x00000020	/* Timeout error */

/*
 *  DMAꥯ
 */
#ifdef TADR_DMAMUX1_BASE
#define DMA_REQUEST_MEM2MEM     0	/* memory to memory transfer */
#define DMA_REQUEST_GENERATOR0  1	/* DMAMUX1 request generator 0 */
#define DMA_REQUEST_GENERATOR1  2	/* DMAMUX1 request generator 1 */
#define DMA_REQUEST_GENERATOR2	3	/* DMAMUX1 request generator 2 */
#define DMA_REQUEST_GENERATOR3  4	/* DMAMUX1 request generator 3 */

#define DMA_REQUEST_ADC1        5	/* DMAMUX1 ADC1 request */
#define DMA_REQUEST_DAC1_CH1    6	/* DMAMUX1 DAC1 CH1 request */
#define DMA_REQUEST_DAC1_CH2    7	/* DMAMUX1 DAC1 CH2 request */
#define DMA_REQUEST_TIM6_UP     8	/* DMAMUX1 TIM6 UP request */
#define DMA_REQUEST_TIM7_UP     9	/* DMAMUX1 TIM7 UP request */
#define DMA_REQUEST_SPI1_RX     10	/* DMAMUX1 SPI1 RX request */
#define DMA_REQUEST_SPI1_TX     11	/* DMAMUX1 SPI1 TX request */
#define DMA_REQUEST_SPI2_RX     12	/* DMAMUX1 SPI2 RX request */
#define DMA_REQUEST_SPI2_TX     13	/* DMAMUX1 SPI2 TX request */
#define DMA_REQUEST_SPI3_RX     14	/* DMAMUX1 SPI3 RX request */
#define DMA_REQUEST_SPI3_TX     15	/* DMAMUX1 SPI3 TX request */
#define DMA_REQUEST_I2C1_RX     16	/* DMAMUX1 I2C1 RX request */
#define DMA_REQUEST_I2C1_TX     17	/* DMAMUX1 I2C1 TX request */
#define DMA_REQUEST_I2C2_RX     18	/* DMAMUX1 I2C2 RX request */
#define DMA_REQUEST_I2C2_TX     19	/* DMAMUX1 I2C2 TX request */
#define DMA_REQUEST_I2C3_RX     20	/* DMAMUX1 I2C3 RX request */
#define DMA_REQUEST_I2C3_TX     21	/* DMAMUX1 I2C3 TX request */
#define DMA_REQUEST_I2C4_RX     22	/* DMAMUX1 I2C4 RX request */
#define DMA_REQUEST_I2C4_TX     23	/* DMAMUX1 I2C4 TX request */
#define DMA_REQUEST_USART1_RX   24	/* DMAMUX1 USART1 RX request */
#define DMA_REQUEST_USART1_TX   25	/* DMAMUX1 USART1 TX request */
#define DMA_REQUEST_USART2_RX   26	/* DMAMUX1 USART2 RX request */
#define DMA_REQUEST_USART2_TX   27	/* DMAMUX1 USART2 TX request */
#define DMA_REQUEST_USART3_RX   28	/* DMAMUX1 USART3 RX request */
#define DMA_REQUEST_USART3_TX   29	/* DMAMUX1 USART3 TX request */
#define DMA_REQUEST_UART4_RX    30	/* DMAMUX1 UART4 RX request  */
#define DMA_REQUEST_UART4_TX    31	/* DMAMUX1 UART4 TX request  */
#define DMA_REQUEST_UART5_RX    32	/* DMAMUX1 UART5 RX request  */
#define DMA_REQUEST_UART5_TX    33	/* DMAMUX1 UART5 TX request  */
#define DMA_REQUEST_LPUART1_RX  34	/* DMAMUX1 LP_UART1_RX request */
#define DMA_REQUEST_LPUART1_TX  35	/* DMAMUX1 LP_UART1_RX request */
#define DMA_REQUEST_SAI1_A      36	/* DMAMUX1 SAI1 A request */
#define DMA_REQUEST_SAI1_B      37	/* DMAMUX1 SAI1 B request */
#define DMA_REQUEST_SAI2_A      38	/* DMAMUX1 SAI2 A request */
#define DMA_REQUEST_SAI2_B      39	/* DMAMUX1 SAI2 B request */
#define DMA_REQUEST_OCTOSPI1    40	/* DMAMUX1 OCTOSPI1 request */
#define DMA_REQUEST_OCTOSPI2    41	/* DMAMUX1 OCTOSPI2 request */
#define DMA_REQUEST_TIM1_CH1    42	/* DMAMUX1 TIM1 CH1 request */
#define DMA_REQUEST_TIM1_CH2    43	/* DMAMUX1 TIM1 CH2 request */
#define DMA_REQUEST_TIM1_CH3    44	/* DMAMUX1 TIM1 CH3 request */
#define DMA_REQUEST_TIM1_CH4    45	/* DMAMUX1 TIM1 CH4 request */
#define DMA_REQUEST_TIM1_UP     46	/* DMAMUX1 TIM1 UP  request */
#define DMA_REQUEST_TIM1_TRIG   47	/* DMAMUX1 TIM1 TRIG request */
#define DMA_REQUEST_TIM1_COM    48	/* DMAMUX1 TIM1 COM request */
#define DMA_REQUEST_TIM8_CH1    49	/* DMAMUX1 TIM8 CH1 request */
#define DMA_REQUEST_TIM8_CH2    50	/* DMAMUX1 TIM8 CH2 request */
#define DMA_REQUEST_TIM8_CH3    51	/* DMAMUX1 TIM8 CH3 request */
#define DMA_REQUEST_TIM8_CH4    52	/* DMAMUX1 TIM8 CH4 request */
#define DMA_REQUEST_TIM8_UP     53	/* DMAMUX1 TIM8 UP  request */
#define DMA_REQUEST_TIM8_TRIG   54	/* DMAMUX1 TIM8 TRIG request */
#define DMA_REQUEST_TIM8_COM    55	/* DMAMUX1 TIM8 COM request */
#define DMA_REQUEST_TIM2_CH1    56	/* DMAMUX1 TIM2 CH1 request */
#define DMA_REQUEST_TIM2_CH2    57	/* DMAMUX1 TIM2 CH2 request */
#define DMA_REQUEST_TIM2_CH3    58	/* DMAMUX1 TIM2 CH3 request */
#define DMA_REQUEST_TIM2_CH4    59	/* DMAMUX1 TIM2 CH4 request */
#define DMA_REQUEST_TIM2_UP     60	/* DMAMUX1 TIM2 UP  request */
#define DMA_REQUEST_TIM3_CH1    61	/* DMAMUX1 TIM3 CH1 request */
#define DMA_REQUEST_TIM3_CH2    62	/* DMAMUX1 TIM3 CH2 request */
#define DMA_REQUEST_TIM3_CH3    63	/* DMAMUX1 TIM3 CH3 request */
#define DMA_REQUEST_TIM3_CH4    64	/* DMAMUX1 TIM3 CH4 request */
#define DMA_REQUEST_TIM3_UP     65	/* DMAMUX1 TIM3 UP  request */
#define DMA_REQUEST_TIM3_TRIG   66	/* DMAMUX1 TIM3 TRIG request */
#define DMA_REQUEST_TIM4_CH1    67	/* DMAMUX1 TIM4 CH1 request */
#define DMA_REQUEST_TIM4_CH2    68	/* DMAMUX1 TIM4 CH2 request */
#define DMA_REQUEST_TIM4_CH3    69	/* DMAMUX1 TIM4 CH3 request */
#define DMA_REQUEST_TIM4_CH4    70	/* DMAMUX1 TIM4 CH4 request */
#define DMA_REQUEST_TIM4_UP     71	/* DMAMUX1 TIM4 UP  request */
#define DMA_REQUEST_TIM5_CH1    72	/* DMAMUX1 TIM5 CH1 request */
#define DMA_REQUEST_TIM5_CH2    73	/* DMAMUX1 TIM5 CH2 request */
#define DMA_REQUEST_TIM5_CH3    74	/* DMAMUX1 TIM5 CH3 request */
#define DMA_REQUEST_TIM5_CH4    75	/* DMAMUX1 TIM5 CH4 request */
#define DMA_REQUEST_TIM5_UP     76	/* DMAMUX1 TIM5 UP  request */
#define DMA_REQUEST_TIM5_TRIG   77	/* DMAMUX1 TIM5 TRIG request */
#define DMA_REQUEST_TIM15_CH1   78	/* DMAMUX1 TIM15 CH1 request */
#define DMA_REQUEST_TIM15_UP    79	/* DMAMUX1 TIM15 UP  request */
#define DMA_REQUEST_TIM15_TRIG  80	/* DMAMUX1 TIM15 TRIG request */
#define DMA_REQUEST_TIM15_COM   81	/* DMAMUX1 TIM15 COM request */
#define DMA_REQUEST_TIM16_CH1   82	/* DMAMUX1 TIM16 CH1 request */
#define DMA_REQUEST_TIM16_UP    83	/* DMAMUX1 TIM16 UP  request */
#define DMA_REQUEST_TIM17_CH1   84	/* DMAMUX1 TIM17 CH1 request */
#define DMA_REQUEST_TIM17_UP    85	/* DMAMUX1 TIM17 UP  request */
#define DMA_REQUEST_DFSDM1_FLT0 86	/* DMAMUX1 DFSDM1 Filter0 request */
#define DMA_REQUEST_DFSDM1_FLT1 87	/* DMAMUX1 DFSDM1 Filter1 request */
#define DMA_REQUEST_DFSDM1_FLT2 88	/* DMAMUX1 DFSDM1 Filter2 request */
#define DMA_REQUEST_DFSDM1_FLT3 89	/* DMAMUX1 DFSDM1 Filter3 request */
#define DMA_REQUEST_DCMI        90	/* DMAMUX1 DCMI request */
#define DMA_REQUEST_AES_IN      91	/* DMAMUX1 AES IN request */
#define DMA_REQUEST_AES_OUT     92	/* DMAMUX1 AES OUT request */
#define DMA_REQUEST_HASH_IN     93	/* DMAMUX1 HASH IN request */
/*
 *  쥬
 */
#define DMA_REQUEST_0           DMA_REQUEST_ADC1

#else
#define DMA_REQUEST_0           0x00000000
#define DMA_REQUEST_1           0x00000001
#define DMA_REQUEST_2           0x00000002
#define DMA_REQUEST_3           0x00000003
#define DMA_REQUEST_4           0x00000004
#define DMA_REQUEST_5           0x00000005
#define DMA_REQUEST_6           0x00000006
#define DMA_REQUEST_7           0x00000007
#define DMA_REQUEST_8           0x00000008
#define DMA_REQUEST_9           0x00000009
#define DMA_REQUEST_10          0x0000000A
#define DMA_REQUEST_11          0x0000000B
#define DMA_REQUEST_12          0x0000000C
#define DMA_REQUEST_13          0x0000000D
#define DMA_REQUEST_14          0x0000000E
#define DMA_REQUEST_15          0x0000000F
#endif

/*
 *  DMAž
 */
#define DMA_PERIPH_TO_MEMORY    0x00000000		/* Peripheral to memory direction */
#define DMA_MEMORY_TO_PERIPH    DMA_CCR_DIR		/* Memory to peripheral direction */
#define DMA_MEMORY_TO_MEMORY    DMA_CCR_MEM2MEM	/* Memory to memory direction     */

/*
 *  DMAڥեå⡼
 */
#define DMA_PINC_ENABLE         DMA_CCR_PINC	/* Peripheral increment mode enable  */
#define DMA_PINC_DISABLE        0x00000000		/* Peripheral increment mode disable */

/*
 *  DMAå⡼
 */ 
#define DMA_MINC_ENABLE         DMA_CCR_MINC	/* Memory increment mode enable  */
#define DMA_MINC_DISABLE        0x00000000		/* Memory increment mode disable */

/*
 *  DMAڥե롦ǡ
 */
#define DMA_PDATAALIGN_BYTE     0x00000000		/* Peripheral data alignment: Byte     */
#define DMA_PDATAALIGN_HALFWORD DMA_CCR_PSIZE_0	/* Peripheral data alignment: HalfWord */
#define DMA_PDATAALIGN_WORD     DMA_CCR_PSIZE_1	/* Peripheral data alignment: Word     */

/*
 *  DMAꡦǡ
 */
#define DMA_MDATAALIGN_BYTE     0x00000000		/* Memory data alignment: Byte     */
#define DMA_MDATAALIGN_HALFWORD DMA_CCR_MSIZE_0	/* Memory data alignment: HalfWord */
#define DMA_MDATAALIGN_WORD     DMA_CCR_MSIZE_1	/* Memory data alignment: Word     */

/*
 *  DMA⡼
 */
#define DMA_NORMAL              0x00000000		/* Normal mode                  */
#define DMA_CIRCULAR            DMA_CCR_CIRC	/* Circular mode                */

/*
 *  DMAͥ٥٥
 */
#define DMA_PRIORITY_LOW        0x00000000		/* Priority level: Low       */
#define DMA_PRIORITY_MEDIUM     DMA_CCR_PL_0	/* Priority level: Medium    */
#define DMA_PRIORITY_HIGH       DMA_CCR_PL_1	/* Priority level: High      */
#define DMA_PRIORITY_VERY_HIGH  DMA_CCR_PL		/* Priority level: Very High */


/*
 *  DMA¤
 */
typedef struct
{
	uint32_t              Request;		/* Specifies the request selected for the specified channel. */
	uint32_t              Direction;	/* Specifies if the data will be transferred from memory to peripheral */
	uint32_t              PeriphInc;	/* Specifies whether the Peripheral address register should be incremented or not. */
	uint32_t              MemInc;		/* Specifies whether the memory address register should be incremented or not. */
	uint32_t              PeriphDataAlignment;	/* Specifies the Peripheral data width. */
	uint32_t              MemDataAlignment;		/* Specifies the Memory data width. */
	uint32_t              Mode;			/* Specifies the operation mode of the DMAy Streamx. */
	uint32_t              Priority;		/* Specifies the software priority for the DMAy Streamx. */
}DMA_Init_t;

/*
 *  DMAϥɥ鹽¤
 */
typedef struct __DMA_Handle_t DMA_Handle_t;
struct __DMA_Handle_t
{
	uint32_t              base;			/* DMA Port base address */
	uint32_t              cbase;		/* DMA Channel Port address */
	DMA_Init_t            Init;			/* DMA communication parameters */
	uint8_t               chid;			/* channel id */
	uint8_t               chid2;		/* channel id2 */
	uint8_t               chnum;		/* channel number */
	int8_t                genreqno;		/* request GEN number */
	volatile uint32_t     status;		/* DMA status */
	void                  (*xfercallback)(DMA_Handle_t * hdma);		/* DMA transfer complete callback */
	void                  (*xferhalfcallback)(DMA_Handle_t * hdma);	/* DMA Half transfer complete callback */
	void                  (*xferm1callback)(DMA_Handle_t * hdma);	/* DMA transfer complete Memory1 callback */
	void                  (*errorcallback)(DMA_Handle_t * hdma);	/* DMA transfer error callback */
	volatile uint32_t     ErrorCode;	/* DMA Error code */
	void                  *localdata;	/* DMA local data */
};

extern ER dma_init(DMA_Handle_t *hdma);
extern ER dma_deinit(DMA_Handle_t *hdma);
extern ER dma_start(DMA_Handle_t *hdma, uint32_t SrcAddress, uint32_t DstAddress, uint32_t DataLength);
extern ER dma_end(DMA_Handle_t *hdma);
extern void dma_inthandler(DMA_Handle_t *hdma);
extern void channel_dma_isr(intptr_t exinf);


/*
 *  WINDOW-WDOGɥ饤
 */
#define WDOG1_PORTID        1
#define NUM_WDOGPORT        1

typedef struct __WDOG_Init_t
{
	uint32_t              Window;			/* WDOG Window 0x40-0x7F */
	uint32_t              Counter;			/* WDOG 󥫥 0x40-0x7F 0x7F */
	uint32_t              MCounter;			/* WDOG More Counter */
} WDOG_Init_t;

extern ER wdog_init(ID portid, WDOG_Init_t *hwini);
extern ER wdog_deinit(ID portid);
extern ER wdog_reset(ID portod);
extern void wdog_handler(void);


/*
 *  USBΥ
 */
#define ENABLE_FS_BASE1 (TADR_RCC_BASE+TOFF_RCC_AHB2ENR)
#define ENABLE_FS_VAL1  RCC_AHB2ENR_GPIOAEN
#define TADR_FS_G1_BASE TADR_GPIOA_BASE
#define FS_DM_PINNO     11
#define FS_DP_PINNO     12
#define FS_ID_PINNO     10
#define FS_VBUS_PINNO   9
#if defined(TOPPERS_STM32L4R5_NUCLEO144)
#define ENABLE_FS_BASE2 (TADR_RCC_BASE+TOFF_RCC_AHB2ENR)
#define ENABLE_FS_VAL2  RCC_AHB2ENR_GPIOGEN
#define TADR_FS_G2_BASE TADR_GPIOG_BASE
#define FS_POWERSW_PINO 6
#define FS_EVBUS_PINNO  FS_POWERSW_PINO
#endif

#define USB_OTG_FS_WAKEUP_EXTI_LINE         0x00020000	/* External interrupt line 17 Connected to the USB EXTI Line */


/*
 *  LED³ӥå
 */
#define LED01           (1<<0)
#define LED02           (1<<1)
#define LED03           (1<<2)
#define LED04           (1<<3)

#define LED_MASK        (LED01 | LED02 | LED03 | LED04)

/*
 *  LEDȥåξ֥ޥ
 */
#define ON              1     /* LED䥹åON             */
#define OFF             0     /* LED䥹åOFF            */

/*
 *  DIPSW
 */
#define DSW1             0x01
#define DSW2             0x02
#define DSW3             0x04
#define DSW4             0x08

/*
 *  LED³ݡȽ
 */ 
extern void led_init(intptr_t exinf);

/*
 *  LED³ݡɤ߽Ф
 */
uint_t led_in(void);

/*
 *  LED³ݡȽ񤭹
 */ 
void led_out(unsigned int led_data);

/*
 *  LEDȥåθꡦɤ߹ߴؿ
 */
extern void set_led_state(unsigned int led, unsigned char state);

#define NUM_EXTI5_FUNC   5
#define EXTI5_BASENO     5
#define NUM_EXTI10_FUNC  6
#define EXTI10_BASENO    10

#if defined(TOPPERS_STM32L476_DISCOVERY)
#define INHNO_SW1  IRQ_VECTOR_EXTI9_5	/* ߥϥɥֹ */
#define INTNO_SW1  IRQ_VECTOR_EXTI9_5	/* ֹ */
#define INTPRI_SW1      -1			/* ͥ */
#define INTATR_SW1       0			/* ° */
#define sw_handler       exti5_handler
#define INHNO_SW2  IRQ_VECTOR_EXTI0	/* ߥϥɥֹ */
#define INTNO_SW2  IRQ_VECTOR_EXTI0	/* ֹ */
#define INHNO_SW3  IRQ_VECTOR_EXTI1	/* ߥϥɥֹ */
#define INTNO_SW3  IRQ_VECTOR_EXTI1	/* ֹ */
#define INHNO_SW4  IRQ_VECTOR_EXTI2	/* ߥϥɥֹ */
#define INTNO_SW4  IRQ_VECTOR_EXTI2	/* ֹ */
#define INHNO_SW5  IRQ_VECTOR_EXTI3	/* ߥϥɥֹ */
#define INTNO_SW5  IRQ_VECTOR_EXTI3	/* ֹ */

#else
#define INHNO_SW1  IRQ_VECTOR_EXTI15_10	/* ߥϥɥֹ */
#define INTNO_SW1  IRQ_VECTOR_EXTI15_10	/* ֹ */
#define INTPRI_SW1      -1			/* ͥ */
#define INTATR_SW1       0			/* ° */
#define sw_handler       exti10_handler

#endif

extern void (*exti5_func[NUM_EXTI5_FUNC])(void);
extern void (*exti10_func[NUM_EXTI10_FUNC])(void);

/*
 *  PSW³ӥå
 */
#define PSW1             0x00000001
#define PSW_MASK         (PSW1)
#define PSW_CHK_INTERVAL 10


/*
 *  PUSHå³ݡȽ
 */
extern void switch_push_init(intptr_t exinf);

/*
 *  PUSHåХåؿ
 */
extern void setup_sw_func(intptr_t exinf);

/*
 *  PUSHåӥ
 */
extern void sw_isr(intptr_t exinf);

/*
 *  EXTIߥϥɥ
 */
extern void exti5_handler(void);
extern void exti10_handler(void);

/*
 *  DIPSWμФ
 */
uint_t switch_dip_sense(void);


extern void device_info_init(intptr_t exinf);

extern uint_t dipsw_value;

#ifdef __cplusplus
}
#endif

#endif

