/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2018 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: tusbh_bluetooth.c 700 2018-07-05 18:01:10Z roi $
 */
/*
 *  USB Host Middleware BLUETOOTH CLASS
 */

#include "tusbh_bluetooth.h"

#define BLUETOOTH_SENDDATA(d, b, l)   tusbhControlRequest((d), (b), BLUETOOTH_DATA_TYPE, 0, 0, 0, (l))
#define ORDER_MASK  (BT_INTERRUPT_ORDER | BT_CTLWRITE_ORDER | BT_BLKREAD_ORDER | BT_BLKWRITE_ORDER)

static TUSBH_ERCODE tusbhBLUETOOTHInit(TUSBH_Device_t *pdevice);
static TUSBH_ERCODE tusbhBLUETOOTHeInit(TUSBH_Device_t *pdevice);
static TUSBH_ERCODE tusbhBLUETOOTHProcess(TUSBH_Device_t *pdevice, uint8_t *mes);

static TUSBH_Class_t BLUETOOTH_Class = {
	NULL,
	"BLUETOOTH",
	BLUETOOTH_CLASS,
	tusbhBLUETOOTHInit,
	tusbhBLUETOOTHeInit,
	tusbhBLUETOOTHProcess,
	NULL
};

/*
 *  SERIAL饹åȥå״ؿ
 */
void tusbhLinkBLUETOOTH(TUSBH_Handle_t *phost)
{
	tusbhLinkClass(phost, &BLUETOOTH_Class);
}

/*
 *  BLUETOOTH饹
 *  parameter1 pdevice:  ǥХϥɥ
 *  return     TUSBH_ERCODE
 */
static TUSBH_ERCODE
tusbhBLUETOOTHInit(TUSBH_Device_t *pdevice)
{
	uint8_t interface = 0; 
	BLUETOOTH_Handle_t *hblue;
	TUSBH_Handle_t *phost = pdevice->pHost;
	uint8_t max_ep, i;

	interface = tusbhFindInterface(pdevice, pdevice->pClass->classCode, 0x01, 0x01);

	if(interface == NO_INTERFACE){
		syslog_1(LOG_ERROR, "[BLUETOOTH] Cannot Find the interface for %s class.", pdevice->pClass->Name);
		return TUSBH_E_ERR;
	}
	tusbhSelectInterface(pdevice, interface);

	hblue = (BLUETOOTH_Handle_t *)tusbmalloc(sizeof(BLUETOOTH_Handle_t));
	pdevice->pData = hblue;
	memset(hblue, 0, sizeof(BLUETOOTH_Handle_t));
	max_ep = pdevice->ItfDesc[interface].bNumEndpoints;
	if(max_ep < 3 || (pdevice->EpDesc[interface][0].bEndpointAddress & 0x80) == 0)
		return TUSBH_E_ERR;

	hblue->CommInEp     = pdevice->EpDesc[interface][0].bEndpointAddress;
    hblue->CommInEpSize = pdevice->EpDesc[interface][0].wMaxPacketSize;
	hblue->CommInPipe   = tusbhAllocPipe(phost, hblue->CommInEp);
	hblue->poll         = pdevice->EpDesc[interface][0].bInterval;

	if(hblue->poll < BT_MIN_POLL)
		hblue->poll = BT_MIN_POLL;

	for(i = 1 ; i < max_ep; i++){
		if(pdevice->EpDesc[interface][i].bEndpointAddress & 0x80){
			hblue->InEp     = (pdevice->EpDesc[interface][i].bEndpointAddress);
			hblue->InEpSize = pdevice->EpDesc[interface][i].wMaxPacketSize;
			hblue->InPipe = tusbhAllocPipe(phost, hblue->InEp);
		}
		else{
			hblue->OutEp = (pdevice->EpDesc[interface][i].bEndpointAddress);
			hblue->OutEpSize = pdevice->EpDesc[interface][i].wMaxPacketSize;
			hblue->OutPipe = tusbhAllocPipe(phost, hblue->OutEp);
		}
	}

	if(hblue->OutPipe == 0 || hblue->InPipe == 0)
		return TUSBH_E_ERR;

	hblue->state = BLUETOOTH_PROCESS_INIT;
	hblue->timer = 0;
	hblue->pDev = pdevice;

	/*
	 *  NSCͥ륪ץ
	 */
	tusbhOpenPipe(pdevice, hblue->CommInPipe, hblue->CommInEp, USB_EP_TYPE_INTR, 64);
	tusbhHDSetToggle(phost, hblue->CommInPipe, 0);
	tusbhOpenPipe(pdevice, hblue->OutPipe, hblue->OutEp, USB_EP_TYPE_BULK, hblue->OutEpSize);
	tusbhHDSetToggle(phost, hblue->OutPipe, 0);
	tusbhOpenPipe(pdevice, hblue->InPipe, hblue->InEp, USB_EP_TYPE_BULK, hblue->InEpSize);
	tusbhHDSetToggle(phost, hblue->InPipe, 0);

	/* ޡ */
	pdevice->timeid = pdevice->timecount = hblue->poll;
	return TUSBH_E_OK;
}

/*
 *  BLUETOOTH饹λ
 *  parameter1 pdevice:  ǥХϥɥ
 *  return     TUSBH_ERCODE
 */
static TUSBH_ERCODE
tusbhBLUETOOTHeInit(TUSBH_Device_t *pdevice)
{
	BLUETOOTH_Handle_t *hblue;
	TUSBH_Handle_t *phost = pdevice->pHost;

	hblue = (BLUETOOTH_Handle_t *)pdevice->pData;
	hblue->ifstate  &= ~ORDER_MASK;
	if(hblue->CommInPipe != 0){
		tusbhClosePipe(pdevice, hblue->CommInPipe);
		tusbFreePipe(phost, hblue->CommInPipe);
		hblue->CommInPipe = 0;
	}

	if(hblue->OutPipe != 0){
		tusbhClosePipe(pdevice, hblue->OutPipe);
		tusbFreePipe(phost, hblue->OutPipe);
		hblue->OutPipe = 0;
	}

	if(hblue->InPipe != 0){
		tusbhClosePipe(pdevice, hblue->InPipe);
		tusbFreePipe(phost, hblue->InPipe);
		hblue->InPipe = 0;
	}

	if(pdevice->pData != NULL){
		tusbfree(pdevice->pData);
		pdevice->pData = NULL;
	}
	return TUSBH_E_OK;
}

/*
 *  BLUETOOTH饹ץ¹
 *  parameter1 pdevice:  ǥХϥɥ
 *  parameter2 mes:      ̿åؤΥݥ
 *  return     TUSBH_ERCODE
 */
static TUSBH_ERCODE
tusbhBLUETOOTHProcess(TUSBH_Device_t *pdevice, uint8_t *mes)
{
	BLUETOOTH_Handle_t *hblue  = (BLUETOOTH_Handle_t *)pdevice->pData;
	TUSBH_Handle_t *phost = pdevice->pHost;
	void (*func)(TUSBH_Device_t *, uint8_t, int16_t, uint8_t *) = pdevice->pClass->subfunc;
	TUSBH_URBState_t URB_Status = mes[3];
	TUSBH_ERCODE ercd = TUSBH_E_BUSY;
	uint8_t mesreq = 0;
	bool_t  timereq = false;

	if(mes[0] == TUSBH_TIME_EVENT){
		hblue->timer += mes[3];
		pdevice->timeid = pdevice->timecount = hblue->poll;
		timereq = true;
	}
	else if(mes[0] == TUSBH_CLASS_EVENT && mes[2] != 0)
		hblue->state = mes[2];
	switch (hblue->state){
	case BLUETOOTH_PROCESS_INIT:
		if(phost->usrcallback != NULL)
			phost->usrcallback(phost, pdevice, HOST_USER_CLASS_ACTIVE);
		hblue->state = BLUETOOTH_PROCESS_IDLE;
	case BLUETOOTH_PROCESS_IDLE:
		if(timereq && (hblue->ifstate & (BT_INTERRUPT_ORDER | BT_INTERRUPT_REQUEST)) == BT_INTERRUPT_ORDER){
			tusbhInterruptRead(pdevice, &hblue->CommInBuf[0], hblue->CommInEpSize, hblue->CommInPipe);
			hblue->ifstate |= BT_INTERRUPT_REQUEST;
		}
		if(mes[0] != TUSBH_URB_EVENT)
			break;
		if(mes[2] == hblue->CommInPipe){	/* interrupt */
			if(URB_Status == TUSBH_URB_DONE){
				if(func != NULL)
					func(pdevice, HCI_EVENT_PACKET, hblue->CommInEpSize, &hblue->CommInBuf[0]);
				hblue->ifstate &= ~BT_INTERRUPT_REQUEST;
			}
			else if(URB_Status == TUSBH_URB_STALL)
				hblue->state = BLUETOOTH_PROCESS_ERROR;
			else
				hblue->ifstate &= ~BT_INTERRUPT_REQUEST;
		}
		else if(mes[2] == hblue->InPipe){	/* blk read */
			if(URB_Status == TUSBH_URB_DONE){
				if(func != NULL)
					func(pdevice, HCI_ACL_DATA_PACKET, tusbhHDTrasLength(phost, hblue->InPipe), hblue->pBRecvBuff);
			}
			else if(URB_Status == TUSBH_URB_NOTREADY){
				hblue->ifstate |= BT_BLKREAD_ORDER;
				mesreq = BLUETOOTH_PROCESS_RECEIVE;
			}
			else if(URB_Status == TUSBH_URB_STALL)
				hblue->state = BLUETOOTH_PROCESS_ERROR;
			else{
				if(func != NULL)
					func(pdevice, HCI_ACL_DATA_PACKET, -1, hblue->pBRecvBuff);
			}
			hblue->ifstate &= ~BT_BLKREAD_REQUEST;
		}
		else if(mes[2] == hblue->OutPipe){	/* blk write */
			if(URB_Status == TUSBH_URB_DONE){
				hblue->BTrnLen += hblue->BTrnCLen;
				if(hblue->BTrnLen >= hblue->BTrnSize){
					if(func != NULL)
						func(pdevice, HCI_SCO_DATA_PACKET, hblue->BTrnSize, NULL);
					if((hblue->ifstate & (BT_CTLWRITE_ORDER | BT_CTLWRITE_REQUEST)) == BT_CTLWRITE_ORDER)
						mesreq = BLUETOOTH_PROCESS_SEND;
				}
				else{
					hblue->ifstate |= BT_BLKWRITE_ORDER;
					mesreq = BLUETOOTH_PROCESS_SEND;
				}
			}
			else if(URB_Status == TUSBH_URB_NOTREADY){
				hblue->ifstate |= BT_BLKWRITE_ORDER;
				mesreq = BLUETOOTH_PROCESS_SEND;
			}
			else if(URB_Status == TUSBH_URB_STALL)
				hblue->state = BLUETOOTH_PROCESS_ERROR;
			else{
				if(func != NULL)
					func(pdevice, HCI_SCO_DATA_PACKET, 0, NULL);
				if((hblue->ifstate & (BT_CTLWRITE_ORDER | BT_CTLWRITE_REQUEST)) == BT_CTLWRITE_ORDER)
					mesreq = BLUETOOTH_PROCESS_SEND;
			}
			hblue->ifstate &= ~BT_BLKWRITE_REQUEST;
		}
		else{								/* control write */
			TUSBH_ERCODE status = tusbhControlWait(pdevice, mes);
			if(status == TUSBH_E_OK){
				hblue->ifstate &= ~BT_CTLWRITE_REQUEST;
				if(func != NULL)
					func(pdevice, HCI_COMMAND_DATA_PACKET, hblue->CTrnSize, hblue->pCTrnBuff);
				if((hblue->ifstate & BT_INTERRUPT_STOP) == 0)
					hblue->ifstate  |= BT_INTERRUPT_ORDER;
				if((hblue->ifstate & (BT_BLKWRITE_ORDER | BT_BLKWRITE_REQUEST)) == BT_BLKWRITE_ORDER)
					mesreq = BLUETOOTH_PROCESS_SEND;
			}
			else if(status != TUSBH_E_BUSY && status != TUSBH_E_BUSY_URB){
				hblue->state = BLUETOOTH_PROCESS_ERROR;
				hblue->ifstate  &= ~BT_CTLWRITE_REQUEST;
			}
		}
		tusbSendData(phost->process_event, TUSBH_CLASS_EVENT, pdevice->idx, mesreq, 0);
		break;
	case BLUETOOTH_PROCESS_SEND:
		if((hblue->ifstate & (BT_CTLWRITE_ORDER | BT_CTLWRITE_REQUEST | BT_BLKWRITE_REQUEST)) == BT_CTLWRITE_ORDER){
			BLUETOOTH_SENDDATA(pdevice, hblue->pCTrnBuff, hblue->CTrnSize);
			hblue->ifstate |= BT_CTLWRITE_REQUEST;
			hblue->ifstate &= ~BT_CTLWRITE_ORDER;
		}
		if((hblue->ifstate & (BT_BLKWRITE_ORDER | BT_BLKWRITE_REQUEST | BT_CTLWRITE_REQUEST)) == BT_BLKWRITE_ORDER){
			hblue->BTrnCLen = hblue->BTrnSize - hblue->BTrnLen;
			if(hblue->BTrnCLen > hblue->OutEpSize)
				hblue->BTrnCLen = hblue->OutEpSize;
			tusbhBulkWrite(pdevice, &hblue->pBTrnBuff[hblue->BTrnLen], hblue->BTrnCLen, hblue->OutPipe);
			hblue->ifstate |= BT_BLKWRITE_REQUEST;
			hblue->ifstate &= ~BT_BLKWRITE_ORDER;
		}
		hblue->state = BLUETOOTH_PROCESS_IDLE;
		break;
	case BLUETOOTH_PROCESS_RECEIVE:
		if((hblue->ifstate & (BT_BLKREAD_ORDER | BT_BLKREAD_REQUEST)) == BT_BLKREAD_ORDER){
			tusbhBulkRead(pdevice, hblue->pBRecvBuff, hblue->BRecvSize, hblue->InPipe);
			hblue->ifstate &= ~BT_BLKREAD_ORDER;
			hblue->ifstate |= BT_BLKREAD_REQUEST;
		}
		hblue->state = BLUETOOTH_PROCESS_IDLE;
		break;
	case BLUETOOTH_PROCESS_ERROR:
		break;
	default:
		break;
	}
	return ercd;
}


/*
 *  BLUETOOTH TRANSFAR READY
 *  parameter1 phost:   ۥȥϥɥ
 *  parameter2 unit:    UNIT#
 *  parameter3 mode:    ǧ⡼
 *  return     bool
 */
bool_t
tusbhBluetoothTransfarReady(TUSBH_Handle_t *phost, uint8_t unit, uint8_t mode)
{
	TUSBH_Device_t *pdevice = tusbhSearchDevice(phost, BLUETOOTH_Class.classCode, &unit);
	BLUETOOTH_Handle_t *hblue;
	bool_t result = false;

	if(pdevice != NULL){
		hblue = pdevice->pData;
		if(pdevice->dstate != DEVICE_CLASS)
			return false;
		if(hblue->state == BLUETOOTH_PROCESS_ERROR)
			return false;
	}
	else
		return false;
	switch(mode){
	case HCI_COMMAND_DATA_PACKET:
		result = (hblue->ifstate & (BT_CTLWRITE_ORDER | BT_CTLWRITE_REQUEST)) == 0;
		break;
	case HCI_ACL_DATA_PACKET:
		result = (hblue->ifstate & (BT_BLKREAD_ORDER | BT_BLKREAD_REQUEST)) == 0;
		break;
	case HCI_SCO_DATA_PACKET:
		result = (hblue->ifstate & (BT_BLKWRITE_ORDER | BT_BLKWRITE_REQUEST)) == 0;
		break;
	case HCI_EVENT_PACKET:
		result = (hblue->ifstate & BT_INTERRUPT_REQUEST) == 0;
		break;
	default:
		break;
	}
	return result;
}

/*
 *  BLUETOOTH INTERRUPT POLL TIMING
 *  parameter1 phost:   ۥȥϥɥ
 *  parameter2 unit:    UNIT#
 *  parameter3 mode:    ǧ⡼
 *  return     bool
 */
TUSBH_ERCODE
tusbhBluetoothInterruptPollTiming(TUSBH_Handle_t *phost, uint8_t unit, uint32_t timing)
{
	TUSBH_Device_t *pdevice = tusbhSearchDevice(phost, BLUETOOTH_Class.classCode, &unit);
	BLUETOOTH_Handle_t *hblue;

	if(pdevice != NULL){
		hblue = pdevice->pData;
		if(pdevice->dstate != DEVICE_CLASS)
			return TUSBH_E_OBJ;
		if(hblue->state == BLUETOOTH_PROCESS_ERROR)
			return TUSBH_E_ERR;
	}
	else
		return TUSBH_E_OBJ;
	if(timing == 0){
		hblue->ifstate |= BT_INTERRUPT_STOP;
		hblue->ifstate &= ~BT_INTERRUPT_ORDER;
	}
	else{
		if(timing < BT_MIN_POLL)
			hblue->poll = BT_MIN_POLL;
		else
			hblue->poll = timing;
		hblue->ifstate &= ~BT_INTERRUPT_STOP;
		hblue->ifstate |= BT_INTERRUPT_ORDER;
	}
	return TUSBH_E_OK;
}

/*
 *  BLUETOOTH DATA SEND
 *  parameter1 phost:   ۥȥϥɥ
 *  parameter2 unit:    UNIT#
 *  parameter3 mode:    ѥåȥ
 *  parameter4 pbuf:    ǡΰؤΥݥ(cache aline)
 *  parameter5 length:  ǡĹ
 *  return     TUSBH_ERCODE
 */
TUSBH_ERCODE
tusbhBluetoothSend(TUSBH_Handle_t *phost, uint8_t unit, uint8_t mode, uint8_t *pbuf, uint16_t length)
{
	TUSBH_Device_t *pdevice = tusbhSearchDevice(phost, BLUETOOTH_Class.classCode, &unit);
	BLUETOOTH_Handle_t *hblue;

	if(pdevice != NULL){
		hblue = pdevice->pData;
		if(pdevice->dstate != DEVICE_CLASS)
			return TUSBH_E_OBJ;
		if(hblue->state == BLUETOOTH_PROCESS_ERROR)
			return TUSBH_E_ERR;
	}
	else
		return TUSBH_E_OBJ;

    /*
	 *  ǡ
	 */
	if(mode == HCI_COMMAND_DATA_PACKET){
		if(length > BT_CONTROL_SIZE)
			return TUSBH_E_PAR;
		if((hblue->ifstate & BT_CTLWRITE_ORDER) != 0)
			return TUSBH_E_OBJ;
		hblue->CTrnSize  = length;
		hblue->pCTrnBuff = pbuf;
		hblue->ifstate |= BT_CTLWRITE_ORDER;
	}
	else if(mode == HCI_SCO_DATA_PACKET){
		if((hblue->ifstate & BT_BLKWRITE_ORDER) != 0)
			return TUSBH_E_OBJ;
		hblue->BTrnSize   = length;
		hblue->BTrnLen    = 0;
		hblue->BTrnCLen   = 0;
		hblue->pBTrnBuff  = pbuf;
		hblue->ifstate |= BT_BLKWRITE_ORDER;
	}
	else
		return TUSBH_E_PAR;
	tusbSendData(phost->process_event, TUSBH_CLASS_EVENT, pdevice->idx, BLUETOOTH_PROCESS_SEND, 0);
	return TUSBH_E_OK;
}

/*
 *  BLUETOOTH RECEIVE BULK IN
 *  parameter1 phost:   ۥȥϥɥ
 *  parameter2 unit:    UNIT#
 *  parameter3 pbuf:    ǡΰؤΥݥ(cache aline)
 *  parameter4 length:  ǡĹ
 *  return     TUSBH_ERCODE
 */
TUSBH_ERCODE
tusbhBluetoothReceiveBulk(TUSBH_Handle_t *phost, uint8_t unit, uint8_t *pbuf, uint16_t length)
{
	TUSBH_Device_t *pdevice = tusbhSearchDevice(phost, BLUETOOTH_Class.classCode, &unit);
	BLUETOOTH_Handle_t *hblue;

	if(pdevice != NULL){
		hblue = pdevice->pData;
		if(pdevice->dstate != DEVICE_CLASS)
			return TUSBH_E_OBJ;
	}
	else
		return TUSBH_E_OBJ;
	if(length < hblue->InEpSize)
		return TUSBH_E_PAR;
	hblue->BRecvSize  = length;
	hblue->pBRecvBuff = pbuf;
	hblue->ifstate |= BT_BLKREAD_ORDER;
	tusbSendData(phost->process_event, TUSBH_CLASS_EVENT, pdevice->idx, BLUETOOTH_PROCESS_RECEIVE, 0);
	return TUSBH_E_OK;
}

/*
 *  BLUETOOTHХåؿ
 *  parameter1 phost:   ۥȥϥɥ
 *  parameter2 func:    ؿݥ
 */
void
tusbhSetBluetoothCallBack(TUSBH_Handle_t *phost, void (*func)(TUSBH_Device_t *p, uint8_t, int16_t, uint8_t *))
{
	BLUETOOTH_Class.subfunc = func;
}


